#include "Main.h"
#include "CoverFire.h"

// 
static CRand Rand;
static float Rand1() { return Rand.Real1(); }
static float Rand05() { return Rand.Real1()-0.5f; }

// 萔
const static float 
	InitXZ=0.0f, InitY=1.0f, 
	MinSize=0.3f, MaxSize=0.5f, 
	MinVY=0.03f, MaxVY=0.05f,
	RandColor=0.2f;

//==============================================================
// 

// RXgN^
CEachCoverFire::CEachCoverFire(
	D3DXVECTOR3 base_color, float max_xz,
	int min_time, int max_time
)
:	BaseColor(base_color), MaxXZ(max_xz),
	MinTime(min_time), MaxTime(max_time)
{
	// eNX`W
	Vertex[0].UV=D3DXVECTOR2(0, 0);
	Vertex[1].UV=D3DXVECTOR2(1, 0);
	Vertex[2].UV=D3DXVECTOR2(0, 1);
	Vertex[3].UV=D3DXVECTOR2(1, 1);
	
	// 
	Init();
	for (int i=0, n=Rand1()*MaxTime; i<n; i++) Move();
}

// 
void CEachCoverFire::Init() {

	// WAxATCY
	float rad=Rand1()*D3DX_PI*2, xz=Rand05()*MaxXZ;
	Pos=D3DXVECTOR3(
		InitXZ+cos(rad)*xz, InitY, InitXZ);//+sin(rad)*xz);
	VPos=D3DXVECTOR3(
		0, MinVY+(MaxVY-MinVY)*Rand1(), 0);
	Size=MinSize+(MaxSize-MinSize)*Rand1();

	// F
	float c=Rand05()*RandColor;
	Color=BaseColor+D3DXVECTOR3(c, c, c);

	// 
	Time=0;
	EndTime=MinTime+(MaxTime-MinTime)*Rand1();
}

// ړ
void CEachCoverFire::Move() {

	// WƎԂ̍XV
	Pos+=VPos;
	Time++;

	// IԂɂȂĂя
	if (Time>=EndTime) Init();
}

// `
void CEachCoverFire::Draw(
	LPDIRECT3DDEVICE9 device, ID3DXEffect* effect, D3DXMATRIX* wview
) {
	// _W̐ݒ
	D3DXVECTOR4 v=D3DXVECTOR4(Pos, 1);
	D3DXVec4Transform(&v, &v, wview);
	Vertex[0].Pos=D3DXVECTOR3(v.x-Size, v.y+Size, v.z);
	Vertex[1].Pos=D3DXVECTOR3(v.x+Size, v.y+Size, v.z);
	Vertex[2].Pos=D3DXVECTOR3(v.x-Size, v.y-Size, v.z);
	Vertex[3].Pos=D3DXVECTOR3(v.x+Size, v.y-Size, v.z);

	// F̐ݒ
	D3DXVECTOR4 color(
		Color.x, Color.y, Color.z, 
		sin(D3DX_PI*(float)(EndTime-Time)/EndTime));
	effect->SetVector("Color", &color);

	// v~eBu̕`
	UINT p, np;
	effect->Begin(&np, 0);
	for (p=0; p<np; p++) {
		effect->BeginPass(p);
		device->DrawPrimitiveUP(
			D3DPT_TRIANGLESTRIP, 2, 
			Vertex, sizeof(COVERFIRE_VERTEX));
		effect->EndPass();
	}
	effect->End();
}


//==============================================================
// ̃O[v
class CFireGroup {
protected:
	D3DXVECTOR3 Pos;
	D3DXVECTOR3 Color;
	float MaxXZ;
	int Count;
	CEachCoverFire** Fire;
public:
	CFireGroup(D3DXVECTOR3 pos, D3DXVECTOR3 color, int count, 
		float max_xz, int min_time, int max_time)
	:	Pos(pos), Color(color), Count(count) {
		Fire=new CEachCoverFire*[Count];
		for (int i=0; i<Count; i++) {
			Fire[i]=new CEachCoverFire(Color, max_xz, min_time, max_time);
		}
	}
	void Move() {
		for (int i=0; i<Count; i++) Fire[i]->Move();
	}
	void Draw(
		D3DXMATRIX* world, D3DXMATRIX* view, 
		LPDIRECT3DDEVICE9 device, ID3DXEffect* effect
	) {
		D3DXMATRIX wview, trans;
		D3DXMatrixTranslation(&trans, Pos.x, Pos.y, Pos.z);
		wview=trans**world**view;
		for (int i=0; i<Count; i++) Fire[i]->Draw(device, effect, &wview);
	}
};

static D3DXVECTOR3 CharPos[]={
	D3DXVECTOR3(0, 0, -1.0f),
	D3DXVECTOR3(1.2f, 0, 0.5f),
	D3DXVECTOR3(-1.2f, 0, 0.5f)
};
static CFireGroup* FireGroup[]={
	new CFireGroup(D3DXVECTOR3(0, -1.2f, -0.5f), D3DXVECTOR3(0.02f, 0.03f, 0.05f), 600, 1.3f, 10, 60),
	new CFireGroup(D3DXVECTOR3(0, -2.5f, -1.0f), D3DXVECTOR3(0.02f, 0.03f, 0.05f), 200, 2.0f, 10, 30),
	new CFireGroup(D3DXVECTOR3(1.0f, -2.5f, -0.5f), D3DXVECTOR3(0.02f, 0.03f, 0.05f), 200, 2.0f, 10, 30),
	new CFireGroup(D3DXVECTOR3(-1.0f, -2.5f, -0.5f), D3DXVECTOR3(0.02f, 0.03f, 0.05f), 200, 2.0f, 10, 30),

	new CFireGroup(D3DXVECTOR3(1.2f, -1.2f, 1.0f), D3DXVECTOR3(0.02f, 0.05f, 0.03f), 600, 1.3f, 10, 60),
	new CFireGroup(D3DXVECTOR3(1.2f, -2.5f, 0.5f), D3DXVECTOR3(0.02f, 0.05f, 0.03f), 200, 2.0f, 10, 40),
	new CFireGroup(D3DXVECTOR3(2.2f, -2.5f, 1.0f), D3DXVECTOR3(0.02f, 0.05f, 0.03f), 200, 2.0f, 10, 30),
	new CFireGroup(D3DXVECTOR3(0.2f, -2.5f, 1.0f), D3DXVECTOR3(0.02f, 0.05f, 0.03f), 200, 2.0f, 10, 30),

	new CFireGroup(D3DXVECTOR3(-1.2f, -1.2f, 1.0f), D3DXVECTOR3(0.05f, 0.03f, 0.02f), 600, 1.3f, 10, 60),
	new CFireGroup(D3DXVECTOR3(-1.2f, -2.5f, 0.5f), D3DXVECTOR3(0.05f, 0.03f, 0.02f), 200, 2.0f, 10, 30),
	new CFireGroup(D3DXVECTOR3(-2.2f, -2.5f, 1.0f), D3DXVECTOR3(0.05f, 0.03f, 0.02f), 200, 2.0f, 10, 30),
	new CFireGroup(D3DXVECTOR3(-0.2f, -2.5f, 1.0f), D3DXVECTOR3(0.05f, 0.03f, 0.02f), 200, 2.0f, 10, 30),
};
static D3DXCOLOR CharColor[]={
	D3DXCOLOR(0.3f, 0.2f, 0.5f, 1),
	D3DXCOLOR(0.2f, 0.5f, 0.3f, 1), 
	D3DXCOLOR(0.5f, 0.3f, 0.2f, 1)
};

static int FireGroupCount=sizeof(FireGroup)/sizeof(CFireGroup*);


//==============================================================
// \

// RXgN^
CCoverFire::CCoverFire(
	CMain* main, string title, int mode, float vyaw,
	D3DXVECTOR3 from, D3DXVECTOR3 lookat
)
:	CDemo(main, title), Mode(mode), 
	Yaw(0), VYaw(vyaw), CircleYaw(0),
	From(from), Lookat(lookat)
{
	// bṼ[h
	Mesh[0]=LoadMesh("penguin.x");
	Mesh[1]=LoadMesh("pekema.x");
	Mesh[2]=LoadMesh("bear.x");
	MeshCircle=LoadMesh("SceneMagicCircle_Circle.x");

	// GtFNg̃[h
	Effect=LoadEffect("Smoke.fx");

	// eNX`̃[h
	Texture=LoadTexture("Smoke.png");
}

// fXgN^
CCoverFire::~CCoverFire() {
}
	
// ړ
void CCoverFire::Move() {

	// V[̉]
	Yaw+=VYaw;
	CircleYaw+=0.01f;

	// 𓮂
	for (int i=0; i<FireGroupCount; i++) FireGroup[i]->Move();
}

// `
void CCoverFire::Draw() {

	// [hs
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, Yaw);

	// r[s
	D3DXMATRIX view;
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&view, &From, &Lookat, &up);
	Device->SetTransform(D3DTS_VIEW, &view);
	
	// ˉes
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMATRIX proj;
	D3DXMatrixPerspectiveLH(&proj, 1, h/w, 1, 1000);
	Device->SetTransform(D3DTS_PROJECTION, &proj);

	// Cg
	for (int i=0; i<3; i++) {
		Graphics->SetLight(
			i, D3DLIGHT_POINT, 
			D3DXVECTOR3(CharPos[i].x, -3.0f, CharPos[i].z-0.1f), D3DXVECTOR3(0, 0, 0), 
			CharColor[i], 1000);
		Graphics->SetLight(
			i+3, D3DLIGHT_POINT, 
			D3DXVECTOR3(CharPos[i].x, 5.0f, CharPos[i].z-0.1f), D3DXVECTOR3(0, 0, 0), 
			CharColor[i], 1000);
	}

	// 
	D3DXCOLOR ambient(0.2f, 0.2f, 0.2f, 1);
	Device->SetRenderState(D3DRS_AMBIENT, ambient);

	//========================================================================
	// bV
	
	// V[̕`
	Graphics->Clear();
	for (int i=0; i<3; i++) {

		// [hs
		D3DXMATRIX mw, mt;
		D3DXMatrixTranslation(&mt, CharPos[i].x, CharPos[i].y, CharPos[i].z);
		mw=mt*world;
		Device->SetTransform(D3DTS_WORLD, &mw);

		// bV̕`		
		Mesh[i]->Draw();
	}

	//========================================================================
	// 

	// At@ufBO̐ݒiZj
	Device->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
	Device->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_ONE);

	// _`AsAeNX`AeNjbN̐ݒ
	Device->SetFVF(D3DFVF_COVERFIRE_VERTEX);
	Effect->SetMatrix("Proj", &proj);
	Effect->SetTexture("Tex", Texture);
	Effect->SetTechnique("Smoke");
	
	// 
	for (int i=0; i<FireGroupCount; i++) {
		FireGroup[i]->Draw(&world, &view, Device, Effect);
	}

	// At@ufBO̐ݒiʏj
	Device->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
	Device->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);
}

