#include "Main.h"
#include "CoverMonitor.h"


//==============================================================
// Cuj^

// RXgN^
CCoverMonitor::CCoverMonitor(
	CMain* main, float vyaw, 
	D3DXVECTOR3 from, D3DXVECTOR3 lookat
)
:	CDemo(main, ""), Target(0),
	Yaw(0), VYaw(vyaw), Time(0), 
	From(from), Lookat(lookat)
{
	// bṼ[h
	MeshA=LoadMesh("SceneCoverMonitorA.x");
	MeshB=LoadMesh("SceneCoverMonitorB.x");
}

// fXgN^
CCoverMonitor::~CCoverMonitor() {
}
	
// ړ
void CCoverMonitor::Move() {
	Yaw+=VYaw;
	Time++;
	Target=1-Target;
}

// `
void CCoverMonitor::Draw() {

	// G[`FbN
	if (!MeshA) { Error="MeshA"; return; }
	if (!MeshB) { Error="MeshB"; return; }

	// [hs
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, Yaw);
	Device->SetTransform(D3DTS_WORLD, &world);

	// r[s
	D3DXMATRIX view;
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&view, &From, &Lookat, &up);
	Device->SetTransform(D3DTS_VIEW, &view);
	
	// ˉes
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMATRIX proj;
	D3DXMatrixPerspectiveLH(&proj, 1, h/w, 1, 1000);
	Device->SetTransform(D3DTS_PROJECTION, &proj);

	// Cg
	for (int i=0; i<8; i++) Device->LightEnable(i, FALSE);
	Graphics->SetLight(0, D3DLIGHT_DIRECTIONAL, 1, -1, 1, 1000);

	// 
	D3DXCOLOR ambient(0.2f, 0.2f, 0.2f, 1);
	Device->SetRenderState(D3DRS_AMBIENT, ambient);

	// eNX`0ɃV[`
	CMesh* mesh=Time%2?MeshB:MeshA;
	SetRenderTarget(WorkTexture[Target], WorkDepthStencil[Target]);
	Graphics->Clear(BGColor);
	mesh->Draw();

	// Cuj^̕`
	for (DWORD i=0, n=mesh->GetNumMaterials(); i<n; i++) {
		D3DMATERIAL9* mat=mesh->GetMaterial(i);
		Device->SetMaterial(mat);
		
		// Emissive0ȊO̕ɃeNX`1Kpĕ`
		if (mat->Emissive.r+mat->Emissive.g+mat->Emissive.b!=0) {
			Device->SetTexture(0, WorkTexture[1-Target]);
			mesh->DrawSubset(i);
		}
	}

	// eNX`0ʂɕ`
	ResetRenderTarget();
	SetSamplerState(0, D3DTEXF_POINT);
	DrawTexture(WorkTexture[0], 0, 0, w, h, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));
	SetSamplerState(0, D3DTEXF_LINEAR);
}
