#include "Main.h"
#include "CoverWave.h"

#define TEX_SIZE 256
LPDIRECT3DTEXTURE9 CCoverWave::HeightTexture[2]={NULL, NULL};
LPDIRECT3DTEXTURE9 CCoverWave::NormalTexture=NULL;

// 
static CRand Rand;
static float Rand1() { return Rand.Real1(); }
static float Rand05() { return Rand.Real1()-0.5f; }

// 萔
static float 
	MaxVXZ=0.05f, MaxAXZ=0.005f, 
	MinSize=1.0f, MaxSize=1.4f, 
	DirScale=1.0f, VDirScale=0.05f,
	MinVY=-0.01f, MaxVY=-0.02f,
	MaxXZ=10, MaxY=5, MinY=-2;

//==============================================================
// t

// RXgN^
CEachCoverSakura::CEachCoverSakura(CMesh* mesh) 
:	Mesh(mesh)
{
	// WAAxATCYAgpbVԍ̐ݒ
	Init();
}

// 
void CEachCoverSakura::Init() {

	// WAx
	Pos=D3DXVECTOR3(Rand05()*MaxXZ, Rand1()*MaxY, Rand05()*MaxXZ);
	VPos=D3DXVECTOR3(Rand05()*MaxVXZ, MinVY+(MaxVY-MinVY)*Rand1(), Rand05()*MaxVXZ);

	// ]A]x
	Dir=D3DXVECTOR3(Rand1(), Rand1(), Rand1())*D3DX_PI*2*DirScale;
	VDir=D3DXVECTOR3(Rand05(), Rand05(), Rand05())*VDirScale;

	// TCY
	Size=MinSize+(MaxSize-MinSize)*Rand1();
}

// ړ
void CEachCoverSakura::Move() {

	// A]A̗h
	Pos+=VPos;
	Dir+=VDir;
	VPos.x+=Rand05()*MaxAXZ;
	VPos.z+=Rand05()*MaxAXZ;

	// nʂɗWAxATCYAgpbVԍĐݒ
	if (Pos.y<MinY) {
		Init();
		Pos.y=MaxY;
	}
}

// `
void CEachCoverSakura::Draw(
	LPDIRECT3DDEVICE9 device, 
	const D3DXMATRIX* world
) {
	// [hs̐ݒ
	D3DXMATRIX m0, m1, m2;
	D3DXMatrixScaling(&m0, Size, Size, Size);
	D3DXMatrixRotationYawPitchRoll(&m1, Dir.x, Dir.y, Dir.z);
	D3DXMatrixTranslation(&m2, Pos.x, Pos.y, Pos.z);

	D3DXMatrixMultiply(&m0, &m0, &m1);
	D3DXMatrixMultiply(&m0, &m0, &m2);
	D3DXMatrixMultiply(&m0, &m0, world);
	device->SetTransform(D3DTS_WORLD, &m0);

	// bV̕`
	Mesh->Draw(sin(D3DX_PI*(MaxY-Pos.y)/(MaxY-MinY)));
}

//==============================================================
// g

// RXgN^
CCoverWave::CCoverWave(
	CMain* main, float vyaw, 
	D3DXVECTOR3 from, D3DXVECTOR3 lookat, 
	int sakura_count
)
:	CDemo(main, ""), Yaw(0), VYaw(vyaw), 
	From(from), Lookat(lookat), 
	LightWVPos(D3DXVECTOR4(-10, 10, -10, 1)), 
	LightColor(D3DXVECTOR4(0.9f, 0.9f, 1.0f, 1)), 
	Time(0), TextureTime(0),
	SakuraCount(sakura_count)
{
	// bṼ[h
	Mesh=LoadMesh("SceneCoverFishing.x");
	MeshWave=LoadMesh("SceneFishing_Wave.x");
	
	// GtFNg̃[h
	Effect=LoadEffect("Wave.fx");

	// ̍쐬
	MeshSakura=LoadMesh("Sakura0.x");
	Sakura=new CEachCoverSakura*[SakuraCount];
	for (int i=0; i<SakuraCount; i++) {
		Sakura[i]=new CEachCoverSakura(MeshSakura);
	}
}

// foCXZbg
void CCoverWave::OnResetDevice() {
	CDemo::OnResetDevice();

	// x}bv̍쐬
	for (int i=0; i<2; i++) {
		if (!HeightTexture[i]) {
			Device->CreateTexture(
				TEX_SIZE, TEX_SIZE, 1, D3DUSAGE_RENDERTARGET, D3DFMT_G16R16F, 
				D3DPOOL_DEFAULT, &HeightTexture[i], NULL);
		}
	}

	// @}bv̍쐬
	if (!NormalTexture) {
		Device->CreateTexture(
			TEX_SIZE, TEX_SIZE, 1, D3DUSAGE_RENDERTARGET, D3DFMT_G16R16F, 
			D3DPOOL_DEFAULT, &NormalTexture, NULL);
	}
	
	// eNX`̃NA
	for (int i=0; i<2; i++) {
		if (HeightTexture[i]) {
			SetRenderTarget(HeightTexture[i], NULL);
			Device->Clear(0, NULL, D3DCLEAR_TARGET, 0, 1, 0);
		}
	}
	if (NormalTexture) {
		SetRenderTarget(NormalTexture, NULL);
		Device->Clear(0, NULL, D3DCLEAR_TARGET, 0, 1, 0);
	}
	ResetRenderTarget();
}

// foCXXg
void CCoverWave::OnLostDevice() {
	CDemo::OnLostDevice();
	for (int i=0; i<2; i++) SAFE_RELEASE(HeightTexture[i]);
	SAFE_RELEASE(NormalTexture);
}

// fXgN^
CCoverWave::~CCoverWave() {
	OnLostDevice();
	for (int i=0; i<SakuraCount; i++) delete Sakura[i];
	delete[] Sakura;
}
	
// ړ
void CCoverWave::Move() {
	Time++;
	Yaw+=VYaw;

	// 𓮂
	for (int i=0; i<SakuraCount; i++) Sakura[i]->Move();
}

// `
void CCoverWave::Draw() {

	// G[`FbN
	if (!Mesh) { Error="Mesh"; return; }
	if (!MeshWave) { Error="MeshWave"; return; }
	if (!Effect) { Error="Effect"; return; }
	for (int i=0; i<2; i++) {
		if (!HeightTexture[i]) { Error="HeightTexture"+ToStr(i); return; }
	}
	if (!NormalTexture) { Error="NormalTexture"; return; }

	// [hs
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, Yaw);
	Effect->SetMatrix("World", &world);

	// [hr[s
	D3DXMATRIX view, w_view;
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&view, &From, &Lookat, &up);
	D3DXMatrixMultiply(&w_view, &world, &view);
	Effect->SetMatrix("WView", &w_view);
	
	// [hr[ˉes
	D3DXMATRIX proj, wv_proj;
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMatrixPerspectiveLH(&proj, 1, h/w, 1, 1000);
	Effect->SetMatrix("Proj", &proj);
	D3DXMatrixMultiply(&wv_proj, &w_view, &proj);
	Effect->SetMatrix("WVProj", &wv_proj);

	// Cg
	Effect->SetVector("LightWVPos", &LightWVPos);
	Effect->SetVector("LightColor", &LightColor);

	// 
	Effect->SetVector("Ambient", &D3DXVECTOR4(0.2f, 0.2f, 0.2f, 1));

	// V[̕`
	ResetRenderTarget();
	Effect->SetTechnique("Scene");
	Graphics->Clear(BGColor);
	DrawMesh(Mesh, Effect);
	
	// g̓
	if (TextureTime!=Time) {
		TextureTime=Time;

		// Vg̐
		if (TextureTime%100==1) {
			Effect->SetVector("AddWavePos", &D3DXVECTOR4(0.6f, 0.3f, 0, 0));
			Effect->SetFloat("AddWaveRad", Rand1()*0.01f);
			Effect->SetFloat("AddWaveVelocity", Rand1());
		}

		// x}bv̍XV
		SetRenderTarget(HeightTexture[TextureTime%2], NULL);
		Effect->SetTexture("HeightTex", HeightTexture[1-TextureTime%2]);
		Effect->SetTechnique("Height");
		Effect->SetFloat("Spring", 0.03f);
		DrawRect(Effect, 0, 0, TEX_SIZE, TEX_SIZE, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));

		// @}bv̍XV
		SetRenderTarget(NormalTexture, NULL);
		Effect->SetTexture("HeightTex", HeightTexture[TextureTime%2]);
		Effect->SetTechnique("Normal");
		DrawRect(Effect, 0, 0, TEX_SIZE, TEX_SIZE, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));
	}

	// g̕`
	ResetRenderTarget();
	Effect->SetTechnique("Wave");
	Effect->SetVector("WaveDiffuse", &D3DXVECTOR4(0.6f, 0.8f, 1.0f, 0.7f));
	Effect->SetVector("WaveSpecular", &D3DXVECTOR4(1.6f, 1.8f, 2.0f, 0));
	Effect->SetFloat("WavePower", 4);
	Effect->SetTexture("NormalTex", NormalTexture);
	Device->SetRenderState(D3DRS_ZWRITEENABLE, FALSE);
	DrawMesh(MeshWave, Effect);
	Device->SetRenderState(D3DRS_ZWRITEENABLE, TRUE);

	// t̕`
	Device->SetTransform(D3DTS_VIEW, &view);
	Device->SetTransform(D3DTS_PROJECTION, &proj);
	for (int i=0; i<8; i++) Device->LightEnable(i, FALSE);
	Graphics->SetLight(
		0, D3DLIGHT_DIRECTIONAL, D3DXVECTOR3(0, 0, 0), 
		D3DXVECTOR3(1, -1, 1), D3DXCOLOR(0.8f, 0.9f, 1.0f, 0), 1000);
	Device->SetRenderState(D3DRS_AMBIENT, D3DXCOLOR(0.3f, 0.3f, 0.3f, 1));
	for (int i=0; i<SakuraCount; i++) Sakura[i]->Draw(Device, &world);
}

