#include "Main.h"
#include "Demo.h"


//==============================================================
// _`

// \
struct VERTEX
{
	// ϊςݒ_
	FLOAT X, Y, Z, RHW;

	// fBt[YF
	D3DCOLOR Diffuse;

	// eNX`W
	FLOAT U0, V0;
	FLOAT U1, V1;
};

// FVF
#define D3DFVF_VERTEX \
	(D3DFVF_XYZRHW|D3DFVF_DIFFUSE|D3DFVF_TEX2|D3DFVF_TEXCOORDSIZE2(0)|D3DFVF_TEXCOORDSIZE2(1))


//==============================================================
// G[`FbN

// PS2.0
bool CDemo::PS20() {
	D3DCAPS9 caps;
	Device->GetDeviceCaps(&caps);
	return caps.PixelShaderVersion>=0xffff0200;
}

//==============================================================

// foCXA_O^[QbgA[xobt@
LPDIRECT3DDEVICE9 CDemo::Device=NULL;
LPDIRECT3DSURFACE9 CDemo::OrgRenderTarget=NULL;
LPDIRECT3DSURFACE9 CDemo::OrgDepthStencil=NULL;

// bV
vector<CMesh*> CDemo::MeshList;
vector<string> CDemo::MeshName;

// GtFNg
vector<ID3DXEffect*> CDemo::EffectList;
vector<string> CDemo::EffectName;

// eNX`
vector<LPDIRECT3DTEXTURE9> CDemo::TextureList;
vector<string> CDemo::TextureName;

// RXgN^
CDemo::CDemo(CMain* main, string title)
:	Main(main), Title(title), 
	Graphics(main->GetGraphics()), 
	ExePath(main->GetExePath()), 
	VertexBuffer(NULL), 
	WorkCount(main->GetWorkCount()),
	WorkTexture(main->GetWorkTexture()),
	WorkDepthStencil(main->GetWorkDepthStencil()), 
	BGColor(D3DCOLOR_XRGB(128, 128, 128))
{
	Device=Graphics->GetDevice();

	// _obt@̍쐬
	Device->CreateVertexBuffer(
		4*sizeof(VERTEX), 0, D3DFVF_VERTEX, 
		D3DPOOL_MANAGED, &VertexBuffer, NULL);
}

// foCXXg̏
void CDemo::OnLostDeviceStatic() {
	for (size_t i=0; i<EffectList.size(); i++) EffectList[i]->OnLostDevice();
	SAFE_RELEASE(OrgRenderTarget);
	SAFE_RELEASE(OrgDepthStencil);
}

// foCXZbg̏
void CDemo::OnResetDeviceStatic() {
	for (size_t i=0; i<EffectList.size(); i++) EffectList[i]->OnResetDevice();
	Device->GetRenderTarget(0, &OrgRenderTarget);
	Device->GetDepthStencilSurface(&OrgDepthStencil);
}

// fXgN^
CDemo::~CDemo() {
	OnLostDevice();
	for (size_t i=0; i<MeshList.size(); i++) SAFE_DELETE(MeshList[i]);
	for (size_t i=0; i<EffectList.size(); i++) SAFE_RELEASE(EffectList[i]);
	SAFE_RELEASE(VertexBuffer);
}


//==============================================================
// Jn
void CDemo::Init() {
	for (int i=0; i<WorkCount; i++) {
		SetRenderTarget(WorkTexture[i], WorkDepthStencil[i]);
		Graphics->Clear();
	}
	ResetRenderTarget();
}

//==============================================================
// bV

// bṼ[h
CMesh* CDemo::LoadMesh(string file) {
	for (size_t i=0; i<MeshList.size(); i++) {
		if (MeshName[i]==file) return MeshList[i];
	}
	string path=ExePath+"..\\Model\\"+file;
	if (!FileExists(path)) return NULL;
	CMesh* mesh=new CMesh(Device);
	mesh->LoadFromFile(path);
	MeshList.push_back(mesh);
	MeshName.push_back(file);
	return mesh;
}

// bV̕`
void CDemo::DrawMesh(CMesh* mesh, ID3DXEffect* effect) {
	for (DWORD i=0, n=mesh->GetNumMaterials(); i<n; i++) {

		// FAeNX`
		effect->SetVector("Diffuse", mesh->GetDiffuse(i));
		effect->SetTexture("MeshTex", GetTexture(mesh, i));
		
		// TuZbg̕`
		UINT p, np;
		effect->Begin(&np, 0);
		for (p=0; p<np; p++) {
			effect->BeginPass(p);
			mesh->DrawSubset(i);
			effect->EndPass();
		}
		effect->End();
	}
}

//==============================================================
// GtFNg

// GtFNg̃[h
ID3DXEffect* CDemo::LoadEffect(string file) {
	for (size_t i=0; i<EffectList.size(); i++) {
		if (EffectName[i]==file) return EffectList[i];
	}

	ID3DXEffect* effect=NULL;
	LPD3DXBUFFER error;

	// GtFNgt@C݂̑mF
	file=ExePath+"..\\Effect\\"+file;
	if (!FileExists(file)) {
		MessageBox(
			NULL, file.c_str(), 
			"Shader File Not Found", MB_OK);
		PostQuitMessage(1);
		return NULL;
	}

	// GtFNgt@C̃[h
	D3DXCreateEffectFromFile(
		Device, file.c_str(), 
		NULL, NULL, 0, NULL, &effect, &error);

	// RpCG[̏ꍇ̓G[\ďI
	if (!effect) {
		MessageBox(
			NULL, 
			error?(LPCTSTR)error->GetBufferPointer():NULL, 
			"Shader Compile Error", MB_OK);
		PostQuitMessage(1);
		return NULL;
	}

	EffectList.push_back(effect);
	EffectName.push_back(file);
	return effect;
}


//==============================================================
// eNX`

// eNX`̃[h
LPDIRECT3DTEXTURE9 CDemo::LoadTexture(string file) {
	for (size_t i=0; i<TextureList.size(); i++) {
		if (TextureName[i]==file) return TextureList[i];
	}
	LPDIRECT3DTEXTURE9 texture=NULL;
	D3DXCreateTextureFromFile(Device, 
		(ExePath+"..\\Image\\"+file).c_str(), &texture);
	TextureList.push_back(texture);
	TextureName.push_back(file);
	return texture;
}

// eNX`̎擾
LPDIRECT3DTEXTURE9 CDemo::GetTexture(CMesh* mesh, int index) {
	LPDIRECT3DTEXTURE9 tex=mesh->GetTexture(index);
	return tex?tex:Main->GetDummyTexture();
}

// eNX`̕`
void CDemo::DrawTexture(
	LPDIRECT3DBASETEXTURE9 texture, 
	float x0, float y0, float x1, float y1, 
	float x2, float y2, float x3, float y3, 
	float u0, float v0, float u1, float v1, 
	D3DCOLOR diffuse
) {
	// eNX`@̐ݒ
	Device->SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_MODULATE);
	Device->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
	Device->SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);
	Device->SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_MODULATE);
	Device->SetTextureStageState(0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE);
	Device->SetTextureStageState(0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE);

	// eNX`̐ݒ
	Device->SetTexture(0, texture);
	
	// lp`̕`
	DrawQuad(x0, y0, x1, y1, x2, y2, x3, y3, u0, v0, u1, v1, diffuse);
}

// GtFNgtŎlp``
void CDemo::DrawQuad(
	ID3DXEffect* effect, 
	float x0, float y0, float x1, float y1, 
	float x2, float y2, float x3, float y3, 
	float u0, float v0, float u1, float v1, 
	D3DCOLOR diffuse
) {
	UINT p, np;
	effect->Begin(&np, 0);
	for (p=0; p<np; p++) {
		effect->BeginPass(p);
		DrawQuad(x0, y0, x1, y1, x2, y2, x3, y3, u0, v0, u1, v1, diffuse);
		effect->EndPass();
	}
	effect->End();
}

// lp`̕`
void CDemo::DrawQuad(
	float x0, float y0, float x1, float y1, 
	float x2, float y2, float x3, float y3, 
	float u0, float v0, float u1, float v1, 
	D3DCOLOR diffuse
) {

	// _obt@foCXɐݒ
	LPDIRECT3DVERTEXBUFFER9 vb=VertexBuffer;
	Device->SetStreamSource(0, vb, 0, sizeof(VERTEX));
	Device->SetFVF(D3DFVF_VERTEX);

	// _obt@̃bN
	VERTEX* v;
	if (SUCCEEDED(
		vb->Lock(0, 4*sizeof(VERTEX), (void**)&v, 0)
	)) {
		// _W̐ݒ
		v[0].X=x0; v[0].Y=y0;
		v[1].X=x1; v[1].Y=y1;
		v[2].X=x2; v[2].Y=y2;
		v[3].X=x3; v[3].Y=y3;

		// eNX`W̐ݒ
		v[0].U0=v[0].U1=u0; v[0].V0=v[0].V1=v0;
		v[1].U0=v[1].U1=u1; v[1].V0=v[1].V1=v0;
		v[2].U0=v[2].U1=u0; v[2].V0=v[2].V1=v1;
		v[3].U0=v[3].U1=u1; v[3].V0=v[3].V1=v1;

		// Z, RHW, _F̐ݒ
		for (int i=0; i<4; i++) {
			v[i].Z=0;
			v[i].RHW=1; 
			v[i].Diffuse=diffuse;
		}

		// _obt@̉
		vb->Unlock();

		// _O̐ݒ
		Device->SetRenderState(D3DRS_ZENABLE, FALSE);
		Device->SetRenderState(D3DRS_ZWRITEENABLE, FALSE);

		// v~eBu̕`
		Device->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);

		// _O̕A
		Device->SetRenderState(D3DRS_ZENABLE, TRUE);
		Device->SetRenderState(D3DRS_ZWRITEENABLE, TRUE);
	}
}

//==============================================================
// TvO
void CDemo::SetSamplerState(DWORD sampler, DWORD value) {
	Device->SetSamplerState(sampler, D3DSAMP_MAGFILTER, value);
	Device->SetSamplerState(sampler, D3DSAMP_MINFILTER, value);
	Device->SetSamplerState(sampler, D3DSAMP_MIPFILTER, value);
}


//==============================================================
// _O^[Qbg̐ݒ

// _O^[Qbg̐ݒi2DeNX`j
void CDemo::SetRenderTarget(
	LPDIRECT3DTEXTURE9 texture, 
	LPDIRECT3DSURFACE9 depth_stencil
) {
	LPDIRECT3DSURFACE9 rt;
	if (SUCCEEDED(texture->GetSurfaceLevel(0, &rt))) {
		Device->SetRenderTarget(0, rt);
		rt->Release();
		Device->SetDepthStencilSurface(depth_stencil);
	}
}

// _O^[Qbg̐ݒiL[ueNX`j
void CDemo::SetRenderTarget(
	LPDIRECT3DCUBETEXTURE9 cube_texture, 
	int face, 
	LPDIRECT3DSURFACE9 depth_stencil
) {
	LPDIRECT3DSURFACE9 rt;
	if (SUCCEEDED(cube_texture->GetCubeMapSurface((D3DCUBEMAP_FACES)face, 0, &rt))) {
		Device->SetRenderTarget(0, rt);
		rt->Release();
		Device->SetDepthStencilSurface(depth_stencil);
	}
}

// _O^[Qbg̏
void CDemo::ResetRenderTarget() {
	Device->SetRenderTarget(0, OrgRenderTarget);
	Device->SetDepthStencilSurface(OrgDepthStencil);
}


