#include "Main.h"
#include "DepthOfField.h"


//==============================================================
// ʊE[x

// RXgN^
CDepthOfField::CDepthOfField(
	CMain* main, string title, 
	float focus_z, float scale, int mode
)
:	CDemo(main, title), Yaw(0), 
	FocusZ(focus_z), Scale(scale), Mode(mode)
{
	// bṼ[h
	Mesh=LoadMesh("SceneSushiArray.x");

	// GtFNg̃[h
	Effect=LoadEffect("DepthOfField.fx");
}

// fXgN^
CDepthOfField::~CDepthOfField() {
}
	
// ړ
void CDepthOfField::Move() {
	Yaw+=0.01f;
}

// `
void CDepthOfField::Draw() {

	// G[`FbN
	if (!Mesh) { Error="Mesh"; return; }
	if (!Effect) { Error="Effect"; return; }
	if (!PS20()) { Error="PS2.0"; return; }

	// [hs
	D3DXMATRIX world, scale;
	D3DXMatrixRotationY(&world, Yaw);
	D3DXMatrixScaling(&scale, 10, 10, 10);
	D3DXMatrixMultiply(&world, &world, &scale);
	Effect->SetMatrix("World", &world);

	// [hr[s
	D3DXMATRIX w_view;
	D3DXVECTOR3 from(0, 15, -100);
	D3DXVECTOR3 lookat(0, 0, 0);
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&w_view, &from, &lookat, &up);
	D3DXMatrixMultiply(&w_view, &world, &w_view);
	Effect->SetMatrix("WView", &w_view);
	
	// [hr[ˉes
	D3DXMATRIX wv_proj;
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMatrixPerspectiveLH(&wv_proj, 1, h/w, 1, 1000);
	D3DXMatrixMultiply(&wv_proj, &w_view, &wv_proj);
	Effect->SetMatrix("WVProj", &wv_proj);

	// Cg
	D3DXVECTOR4 light(1, -1, 1, 0);
	D3DXVec4Normalize(&light, &light);
	Effect->SetVector("Light", &light);

	// 
	D3DXVECTOR4 ambient(0.2f, 0.2f, 0.2f, 1);
	Effect->SetVector("Ambient", &ambient);

	// eNX`0ɃV[Ɛ[x`
	SetRenderTarget(WorkTexture[0], WorkDepthStencil[0]);
	Graphics->Clear(BGColor);

	// GtFNg̃p[^ݒ肷
	Effect->SetFloat("FocusZ", FocusZ);
	Effect->SetFloat("Scale", Scale);
	Effect->SetTechnique("Scene");

	// bV̕`
	for (DWORD i=0, n=Mesh->GetNumMaterials(); i<n; i++) {

		// FƃeNX`̐ݒ
		Effect->SetVector("Diffuse", Mesh->GetDiffuse(i));
		Effect->SetTexture("MeshTex", GetTexture(Mesh, i));
		
		// TuZbg̕`
		UINT p, np;
		Effect->Begin(&np, 0);
		for (p=0; p<np; p++) {
			Effect->BeginPass(p);
			Mesh->DrawSubset(i);
			Effect->EndPass();
		}
		Effect->End();
	}

	// eNX`kpɃ_Oݒ肷
	Device->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
	Device->SetSamplerState(0, D3DSAMP_ADDRESSU, D3DTADDRESS_MIRROR);
	Device->SetSamplerState(0, D3DSAMP_ADDRESSV, D3DTADDRESS_MIRROR);

	// eNX`1ɃeNX`0c1/2ɂĕ`
	SetRenderTarget(WorkTexture[1], WorkDepthStencil[1]);
	DrawTexture(WorkTexture[0], 0, 0, w/2, h/2, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));
	
	// eNX`2ɃeNX`1c1/2ɂĕ`
	// ieNX`2̓eNX`0ɑ΂ďc1/4ɂȂj
	SetRenderTarget(WorkTexture[2], WorkDepthStencil[2]);
	DrawTexture(WorkTexture[1], 0, 0, w/2, h/2, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));

	// _O̕A
	Device->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
	Device->SetSamplerState(0, D3DSAMP_ADDRESSU, D3DTADDRESS_WRAP);
	Device->SetSamplerState(0, D3DSAMP_ADDRESSV, D3DTADDRESS_WRAP);

	// eNX`ĉʂɕ`
	ResetRenderTarget();
	Effect->SetTexture("Tex0", WorkTexture[0]);
	Effect->SetTexture("Tex1", WorkTexture[1]);
	Effect->SetTexture("Tex2", WorkTexture[2]);

	// AȂA[x̕`
	if (Mode<=2) {
		switch (Mode) {
			case 0: Effect->SetTechnique("Blend"); break;
			case 1: Effect->SetTechnique("NoBlend"); break;
			case 2: Effect->SetTechnique("Depth"); break;
		}
		DrawRect(Effect, 0, 0, w, h, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));
	} 
	
	// eNX`̕`
	else {
		int a=Mode-3, b=pow(2, a);
		Graphics->GetDevice()->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
		Device->SetSamplerState(0, D3DSAMP_MAGFILTER, D3DTEXF_POINT);
		Device->SetSamplerState(0, D3DSAMP_MINFILTER, D3DTEXF_POINT);
		Device->SetSamplerState(0, D3DSAMP_MIPFILTER, D3DTEXF_POINT);
		DrawTexture(WorkTexture[a], 0, 0, w, h, 0, 0, 1.0f/b, 1.0f/b, D3DXCOLOR(1, 1, 1, 1));
		Device->SetSamplerState(0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR);
		Device->SetSamplerState(0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR);
		Device->SetSamplerState(0, D3DSAMP_MIPFILTER, D3DTEXF_LINEAR);
		Graphics->GetDevice()->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
	}
}

