//==============================================================
// 萔
float4x4 World;
float4x4 WView;
float4x4 WVProj;
float4 Diffuse;
float4 Ambient;
float3 LightWVPos;
float3 LightColor;
texture MeshTex;

float IceScale;
float4 IceDiffuse;
float4 IceSpecular;
float IcePower;
float3 IceCenter;
float IceRadius;

//==============================================================
// eNX`Tv
sampler MeshSmp=sampler_state {
	Texture=<MeshTex>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
};

//==============================================================
// VF[_iV[j

// _VF[_
void SceneVS (
	float4 pos : POSITION,
	float3 normal : NORMAL,
	float2 mesh_uv : TEXCOORD0,
	out float4 Pos : POSITION,
	out float3 Color : COLOR0,
	out float2 MeshUV : TEXCOORD0
) {
	// _WAeNX`W
	Pos=mul(pos, WVProj);
	MeshUV=mesh_uv;

	// _F
	float3 wv_pos=mul(pos, WView);
	float3 wv_normal=normalize(mul(normal, (float3x3)WView));
	Color=max(0, dot(wv_normal, normalize(LightWVPos-wv_pos)))*LightColor+Ambient;
}

// sNZVF[_
float4 ScenePS(
	float3 Color : COLOR0,
	float2 MeshUV : TEXCOORD0
) : COLOR {

	// eNX`Fƒ_F̍
	return tex2D(MeshSmp, MeshUV)*float4(Color, 1)*Diffuse;
}

//==============================================================
// VF[_iXj

// _VF[_
void IceVS (
	float4 pos : POSITION,
	float3 normal : NORMAL, 
	out float4 Pos : POSITION,
	out float3 WPos : TEXCOORD0, 
	out float3 WVPos : TEXCOORD1,
	out float3 WVNormal : TEXCOORD2
) {
	// _W
	Pos=mul(pos+float4(normal*IceScale, 0), WVProj);
	
	// [hr[ϊ_WƖ@
	WVPos=mul(pos, WView);
	WVNormal=normalize(mul(normal, (float3x3)WView));

	// [hϊ_W
	WPos=mul(pos, World);
}

// sNZVF[_
float4 IcePS(
	float4 Color : COLOR0, 
	float3 WPos : TEXCOORD0, 
	float3 WVPos : TEXCOORD1,
	float3 WVNormal : TEXCOORD0
) : COLOR 
{
	// CeBOi_j
	float3 lp=normalize(LightWVPos-WVPos);
	float hl=dot(lp, normalize(reflect(WVPos, WVNormal)));
	float3 color=
		Ambient+
		max(0, dot(WVNormal, lp))*IceDiffuse+
		pow(hl, IcePower)*IceSpecular;

	// S_苗𓀂点鏈
	float alpha=distance(WPos, IceCenter)<IceRadius?1:0;

	// sNZF̏o
	return float4(color*LightColor, IceDiffuse.a*alpha);
}

//==============================================================
// eNjbN
technique Scene {
	pass P0 {
		VertexShader=compile vs_1_1 SceneVS();
		PixelShader=compile ps_1_1 ScenePS();
	}
}
technique Ice {
	pass P0 {
		VertexShader=compile vs_1_1 IceVS();
		PixelShader=compile ps_2_0 IcePS();
		DestBlend=ONE;
	}
}
technique IceNoAddBlend {
	pass P0 {
		VertexShader=compile vs_1_1 IceVS();
		PixelShader=compile ps_2_0 IcePS();
	}
}
