//==============================================================
// 萔
float4x4 World;
float4x4 WView;
float4x4 WVProj;
float3 Light;
float4 Ambient;
float4 Diffuse;
texture MeshTex;
texture EnvTex;
float Reflectivity;

//==============================================================
// eNX`Tv
sampler MeshSmp=sampler_state {
	Texture=<MeshTex>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
};
samplerCUBE EnvSmp=sampler_state {
	Texture=<EnvTex>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
};

//==============================================================
// VF[_i{j

// _VF[_
void BasicVS (
	float4 pos : POSITION,
	float3 normal : NORMAL,
	float2 mesh_uv : TEXCOORD0,
	out float4 Pos : POSITION,
	out float4 Col : COLOR0,
	out float2 MeshUV : TEXCOORD0
) {
	// _WAeNX`W
	Pos=mul(pos, WVProj);
	MeshUV=mesh_uv;

	// _F
	float3 w_normal=normalize(mul(normal, (float3x3)World));
	Col=max(0, dot(w_normal, -Light))+Ambient;
}

// sNZVF[_
float4 BasicPS(
	float4 Col : COLOR0,
	float2 MeshUV : TEXCOORD0
) : COLOR {

	// eNX`Fƒ_F̍
	return tex2D(MeshSmp, MeshUV)*Col*Diffuse;
}

//==============================================================
// VF[_iˁj

// _VF[_
void ReflectionVS (
	float4 pos : POSITION,
	float3 normal : NORMAL,
	float2 mesh_uv : TEXCOORD0,
	out float4 Pos : POSITION,
	out float4 Col : COLOR0,
	out float2 MeshUV : TEXCOORD0,
	out float3 EnvUV : TEXCOORD1
) {
	// _WAeNX`W
	Pos=mul(pos, WVProj);
	MeshUV=mesh_uv;
	
	// _F
	float3 w_normal=normalize(mul(normal, (float3x3)World));
	Col=max(0, dot(w_normal, -Light))+Ambient;

	// L[ueNX`W
	float3 wv_normal=normalize(mul(normal, WView));
	float3 eye=normalize(mul(pos, WView));
	EnvUV=reflect(eye, wv_normal);
}

// sNZVF[_
float4 ReflectionPS(
	float4 Col : COLOR0,
	float2 MeshUV : TEXCOORD0,
	float3 EnvUV : TEXCOORD1
) : COLOR {
	return 
		Reflectivity*texCUBE(EnvSmp, EnvUV)+
		(1-Reflectivity)*tex2D(MeshSmp, MeshUV)*Col*Diffuse;
}

//==============================================================
// eNjbN
technique Basic {
	pass P0 {
		VertexShader=compile vs_1_1 BasicVS();
		PixelShader=compile ps_1_1 BasicPS();
	}
}
technique Reflection {
	pass P0 {
		VertexShader=compile vs_1_1 ReflectionVS();
		PixelShader=compile ps_1_1 ReflectionPS();
	}
}
