//==============================================================
// 萔
float4x4 World;
float4x4 WView;
float4x4 WVProj;
float4 Diffuse;
float4 Ambient;
float3 LightWVPos;
float3 LightColor;
texture MeshTex;
texture DepthTex0;
texture DepthTex1;
float4 ClearColor;
float4 FogColor;
float FogScale;
float IntScale;

//==============================================================
// eNX`Tv
sampler MeshSmp=sampler_state {
	Texture=<MeshTex>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
};
sampler DepthSmp0=sampler_state {
	Texture=<DepthTex0>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
};
sampler DepthSmp1=sampler_state {
	Texture=<DepthTex1>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
};

//==============================================================
// VF[_iV[j

// _VF[_
void SceneVS (
	float4 pos : POSITION,
	float3 normal : NORMAL,
	float2 mesh_uv : TEXCOORD0,
	out float4 Pos : POSITION,
	out float3 Color : COLOR0,
	out float2 MeshUV : TEXCOORD0
) {
	// _WAeNX`W
	Pos=mul(pos, WVProj);
	MeshUV=mesh_uv;

	// _F
	float3 wv_pos=mul(pos, WView);
	float3 wv_normal=normalize(mul(normal, (float3x3)WView));
	Color=max(0, dot(wv_normal, normalize(LightWVPos-wv_pos)))*LightColor+Ambient;
}

// sNZVF[_
float4 ScenePS(
	float3 Color : COLOR0,
	float2 MeshUV : TEXCOORD0
) : COLOR {

	// eNX`Fƒ_F̍
	return tex2D(MeshSmp, MeshUV)*float4(Color, 1)*Diffuse;
}

//==============================================================
// VF[_iNAj
float4 ClearPS() : COLOR {
	return ClearColor*IntScale;
}

//==============================================================
// VF[_iZlj

// _VF[_
void DepthVS (
	float4 pos : POSITION,
	float2 uv : TEXCOORD0, 
	out float4 Pos : POSITION, 
	out float4 WVPPos : TEXCOORD0,
	out float Z : TEXCOORD1
) {
	// [hr[ˉeϊ_W
	Pos=WVPPos=mul(pos, WVProj);

	// [hr[ϊ_WZl
	float4 wv_pos=mul(pos, WView);
	Z=wv_pos.z/wv_pos.w;
}

// sNZVF[_iV[j
float4 DepthScenePS(
	float Z : TEXCOORD1
) : COLOR 
{
	// RɃV[Zl
	return float4(Z*IntScale, 0, 0, 0);
}

// sNZVF[_itHOj
float4 DepthFogPS(
	float4 WVPPos : TEXCOORD0,
	float Z : TEXCOORD1
) : COLOR 
{
	// eNX`Zl擾
	float2 uv=WVPPos.xy/WVPPos.w*float2(0.5f, -0.5f)+0.5f;
	float d=tex2D(DepthSmp0, uv).r;
	
	// Rɂ̓tHOZlƃV[Zl̏
	// Gɂ1ށisNZ񂾂Ƃj
	return float4(min(Z*IntScale, d), 1, 0, 0);
}

//==============================================================
// VF[_itHOj
float4 FogPS(
	float2 UV : TEXCOORD0
) : COLOR 
{
	// tHO̗ƕ\Zl擾
	float4 t0=tex2D(DepthSmp0, UV), t1=tex2D(DepthSmp1, UV);

	// Zl̍vZ
	float d=saturate((t0.r-t1.r)*FogScale/IntScale);
	
	// Zl̍傫قǃtHOZ`悷
	// ƕ\̗Zl񂾂Ƃ
	// tHO`悷
	return float4(FogColor.rgb, FogColor.a*d*t0.g*t1.g);
}

//==============================================================
// eNjbN

// V[
technique Scene {
	pass P0 {
		VertexShader=compile vs_1_1 SceneVS();
		PixelShader=compile ps_1_1 ScenePS();
	}
}

// NA
technique Clear {
	pass P0 {
		PixelShader=compile ps_2_0 ClearPS();
		ZEnable=FALSE;
		ZWriteEnable=FALSE;
	}
}

// V[Zl
technique DepthScene {
	pass P0 {
		VertexShader=compile vs_1_1 DepthVS();
		PixelShader=compile ps_2_0 DepthScenePS();
		ZFunc=LESS;
	}
}

// tHOZlij
technique DepthFogCW {
	pass P0 {
		VertexShader=compile vs_1_1 DepthVS();
		PixelShader=compile ps_2_0 DepthFogPS();
		CullMode=CW;
		ZFunc=GREATER;
	}
}

// tHOZli\j
technique DepthFogCCW {
	pass P0 {
		VertexShader=compile vs_1_1 DepthVS();
		PixelShader=compile ps_2_0 DepthFogPS();
		CullMode=CCW;
		ZFunc=LESS;
	}
}

// tHO
technique Fog {
	pass P0 {
		PixelShader=compile ps_2_0 FogPS();
	}
}

//==============================================================
// fp

// sNZVF[_iZl̕\j
float4 ShowDepthPS(
	float2 UV : TEXCOORD0
) : COLOR {
	float d=tex2D(DepthSmp0, UV).r*0.05f/IntScale;
	return float4(d, d, d, 1);
}

// sNZVF[_iZl̍̕\j
float4 ShowDepthDiffPS(
	float2 UV : TEXCOORD0
) : COLOR {
	float4 t0=tex2D(DepthSmp0, UV), t1=tex2D(DepthSmp1, UV);
	float d=saturate((t0.r-t1.r)*FogScale/IntScale);
	return float4(d, d, d, t0.g*t1.g);
}

// Zl̕\
technique ShowDepth {
	pass P0 {
		PixelShader=compile ps_2_0 ShowDepthPS();
	}
}

// Zl̍̕\
technique ShowDepthDiff {
	pass P0 {
		PixelShader=compile ps_2_0 ShowDepthDiffPS();
	}
}

