#include "Main.h"
#include "FocusLine.h"


//==============================================================
// W

// RXgN^
CFocusLine::CFocusLine(
	CMain* main, string title, int mode, 
	int line_count, float normal_scale
)
:	CDemo(main, title), 
	Yaw(0), Mode(mode), 
	LineCount(line_count), NormalScale(normal_scale)
{
	// bṼ[h
	MeshObj=LoadMesh("SceneHorror_Obj.x");
	MeshEnv=LoadMesh("SceneHorror_Env.x");

	// GtFNg̃[h
	Effect=LoadEffect("FocusLine.fx");

	// ̈ʒuƑ
	LineRadPos=new float[line_count];
	LineRadWidth=new float[line_count];
}

// fXgN^
CFocusLine::~CFocusLine() {
	delete[] LineRadPos;
	delete[] LineRadWidth;
}
	
// ړ
void CFocusLine::Move() {

	// ̂̉]
	Yaw+=0.03f;

	// ̈ʒuƑ
	float r=D3DX_PI*2/LineCount;
	for (int i=0; i<LineCount; i++) {
		LineRadPos[i]=r*(i+0.1f*Main->Rand05());
		LineRadWidth[i]=r*(0.1f+0.1f*Main->Rand1());
	}
}

// `
void CFocusLine::Draw() {

	// G[`FbN
	if (!MeshObj) { Error="MeshObj"; return; }
	if (!MeshEnv) { Error="MeshEnv"; return; }
	if (!Effect) { Error="Effect"; return; }

	// r[s
	D3DXMATRIX view;
	D3DXVECTOR3 from(0, 5, -10);
	D3DXVECTOR3 lookat(0, 1, 0);
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&view, &from, &lookat, &up);
	Device->SetTransform(D3DTS_VIEW, &view);
	
	// ˉes
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMATRIX proj;
	D3DXMatrixPerspectiveLH(&proj, 1, h/w, 1, 1000);
	Device->SetTransform(D3DTS_PROJECTION, &proj);

	// Cg
	Graphics->SetLight(0, D3DLIGHT_DIRECTIONAL, 1, -1, 1, 1000);

	// 
	D3DXCOLOR ambient(0.2f, 0.2f, 0.2f, 1);
	Device->SetRenderState(D3DRS_AMBIENT, ambient);

	// wi̕`
	Graphics->Clear(BGColor);
	D3DXMATRIX world;
	D3DXMatrixIdentity(&world);
	Device->SetTransform(D3DTS_WORLD, &world);
	MeshEnv->Draw();

	// ̂̕`
	D3DXMatrixRotationY(&world, Yaw);
	Device->SetTransform(D3DTS_WORLD, &world);
	MeshObj->Draw();

	//==========================================================
	// W؂邽߂̂̕`
	
	// GtFNgKpĕ̂`
	D3DXMATRIX wv_proj;
	D3DXMatrixMultiply(&wv_proj, &world, &view);
	D3DXMatrixMultiply(&wv_proj, &wv_proj, &proj);
	Effect->SetMatrix("WVProj", &wv_proj);
	Effect->SetFloat("NormalScale", NormalScale);

	if (Mode==0) {
		Effect->SetTechnique("FocusLine");
	} else {
		Effect->SetTechnique("Mask");
	}

	DrawMesh(MeshObj, Effect);

	//==========================================================
	// W̕`
	
	// SW̌vZ
	D3DXVECTOR4 pos(0, 1, -1, 1);
	D3DXVec4Transform(&pos, &pos, &world);
	D3DXVec4Transform(&pos, &pos, &view);
	D3DXVec4Transform(&pos, &pos, &proj);
	pos.x=w*0.5f*(1+pos.x/pos.w);
	pos.y=h*0.5f*(1-pos.y/pos.w);
	pos.z=0;
	pos.w=1;

	// Zl̔rݒ
	Device->SetRenderState(D3DRS_ZFUNC, D3DCMP_LESS);
	
	// _tH[}bgƃeNX`̐ݒ
	Device->SetFVF(D3DFVF_FOCUSLINE_VERTEX);
	Device->SetTexture(0, Main->GetDummyTexture());

	// ̕`
	for (int i=0; i<LineCount; i++) {
	
		// F̐ݒ
		FOCUSLINE_VERTEX* v=Vertex;
		for (int j=0; j<3; j++) {
			v[j].Color=D3DXCOLOR(0, 0, 0, 1);
		}
		
		// _W̐ݒ
		float l=w*2, r1=LineRadPos[i], r2=LineRadPos[i]+LineRadWidth[i]; 
		v[0].Pos=pos;
		v[1].Pos=v[0].Pos+D3DXVECTOR4(cos(r1)*l, sin(r1)*l, 0, 0);
		v[2].Pos=v[0].Pos+D3DXVECTOR4(cos(r2)*l, sin(r2)*l, 0, 0);

		// eNX`W̐ݒ
		v[0].UV=D3DXVECTOR2(0, 0);
		v[1].UV=D3DXVECTOR2(0, 0);
		v[2].UV=D3DXVECTOR2(0, 0);
		
		// v~eBu̕`
		Device->DrawPrimitiveUP(
			D3DPT_TRIANGLELIST, 1, 
			Vertex, sizeof(FOCUSLINE_VERTEX));
	}

	// Zl̔r𕜋A
	Device->SetRenderState(D3DRS_ZFUNC, D3DCMP_LESSEQUAL);
}

