#include "Main.h"
#include "Footmark.h"


//==============================================================
// 1̑

// RXgN^
CEachFootmark::CEachFootmark() 
:	State(0), Time(0)
{
	for (int i=0; i<4; i++) {
		FOOTMARK_VERTEX* v=&Vertex[i];
		v->Color=D3DXCOLOR(0, 0, 0, 0);
	}
}

// 
void CEachFootmark::Init(
	D3DXVECTOR3& pos, D3DXVECTOR3& v0, D3DXVECTOR3& v1
) {
	// @ƐF̐ݒ
	FOOTMARK_VERTEX* v=Vertex;
	for (int i=0; i<4; i++) {
		v[i].Normal=D3DXVECTOR3(0, 1, 0);
		v[i].Color=D3DXCOLOR(0, 0, 0, 1);
	}

	// _W̐ݒ
	v[0].Pos=pos;
	v[1].Pos=pos+v1;
	v[2].Pos=pos+v0;
	v[3].Pos=pos+v0+v1;

	// eNX`W̐ݒ
	v[0].UV=D3DXVECTOR2(0, 0);
	v[1].UV=D3DXVECTOR2(0, 1);
	v[2].UV=D3DXVECTOR2(1, 0);
	v[3].UV=D3DXVECTOR2(1, 1);

	// ԂƎԂ̐ݒ
	State=1;
	Time=0;
}

// ړ
void CEachFootmark::Move() {
	switch (State) {
		
		// 1Fԑ҂
		case 1:

			// Ԃ̍XV
			Time++;
			
			// 莞Ԃo߂2
			if (Time>=100) {
				Time=0;
				State=2;
			}
			break;
		
		// 2FՂ񂾂
		case 2:

			// At@l̐ݒ
			for (int i=0; i<4; i++) {
				FOOTMARK_VERTEX* v=&Vertex[i];
				v->Color=D3DXCOLOR(0, 0, 0, 1.0f-Time/50.0f);
			}

			// Ԃ̍XV
			Time++;

			// 莞Ԃo߂0
			if (Time>=50) {
				State=0;
			}
			break;
	}
}

// `
void CEachFootmark::Draw(
	LPDIRECT3DDEVICE9 device, LPDIRECT3DTEXTURE9 texture
) {
	// _tH[}bgƃeNX`̐ݒ
	device->SetFVF(D3DFVF_FOOTMARK_VERTEX);
	device->SetTexture(0, texture);

	// v~eBu̕`
	device->DrawPrimitiveUP(
		D3DPT_TRIANGLESTRIP, 2, 
		Vertex, sizeof(FOOTMARK_VERTEX));
}


//==============================================================
// 

// RXgN^
CFootmark::CFootmark(
	CMain* main, string title, 
	string texture_name
)
:	CDemo(main, title), 
	Yaw(0), Time(0), FootmarkIndex(0)
{
	// bṼ[h
	MeshObj=LoadMesh("SceneTrain_Obj.x");
	MeshEnv=LoadMesh("SceneTrain_Env.x");

	// eNX`̃[h
	FootmarkTexture=LoadTexture(texture_name);
}

// fXgN^
CFootmark::~CFootmark() {
}
	
// ړ
void CFootmark::Move() {

	// ̂]
	Yaw+=0.03f;

	// ̂̑ɐVՂǉ
	if (Time%10==0) {
		float c=cos(Yaw), s=-sin(Yaw);
		Footmark[FootmarkIndex].Init(
			D3DXVECTOR3(c*(2.75f+Time/20.0f), FOOTMARK_Y, s*(2.75f+Time/20.0f)), 
			D3DXVECTOR3(c*0.5f, FOOTMARK_Y, s*0.5f), 
			D3DXVECTOR3(-s*0.5f, FOOTMARK_Y, c*0.5f));
		FootmarkIndex=(FootmarkIndex+1)%MAX_FOOTMARK_COUNT;
	}
	Time=(Time+1)%20;
	
	// Ղ𓮂
	for (int i=0; i<MAX_FOOTMARK_COUNT; i++) {
		Footmark[i].Move();
	}
}

// `
void CFootmark::Draw() {

	// G[`FbN
	if (!MeshObj) { Error="MeshObj"; return; }
	if (!MeshEnv) { Error="MeshEnv"; return; }
	if (!FootmarkTexture) { Error="FootmarkTexture"; return; }

	// r[s
	D3DXMATRIX view;
	D3DXVECTOR3 from(0, 5, -10);
	D3DXVECTOR3 lookat(0, 1, 0);
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&view, &from, &lookat, &up);
	Device->SetTransform(D3DTS_VIEW, &view);
	
	// ˉes
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMATRIX proj;
	D3DXMatrixPerspectiveLH(&proj, 1, h/w, 1, 1000);
	Device->SetTransform(D3DTS_PROJECTION, &proj);

	// Cg
	Graphics->SetLight(0, D3DLIGHT_DIRECTIONAL, 1, -1, 1, 1000);

	// 
	D3DXCOLOR ambient(0.2f, 0.2f, 0.2f, 1);
	Device->SetRenderState(D3DRS_AMBIENT, ambient);

	// ̂̕`
	Graphics->Clear(BGColor);
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, Yaw);
	Device->SetTransform(D3DTS_WORLD, &world);
	MeshObj->Draw();

	// wi̕`
	D3DXMatrixIdentity(&world);
	Device->SetTransform(D3DTS_WORLD, &world);
	MeshEnv->Draw();

	// Ղ̕`
	for (int i=0; i<MAX_FOOTMARK_COUNT; i++) {
		Footmark[i].Draw(Device, FootmarkTexture);
	}
}

