#include "Main.h"
#include "LiveMonitor.h"


//==============================================================
// Cuj^

// RXgN^
CLiveMonitor::CLiveMonitor(CMain* main)
:	CDemo(main, "LIVE MONITOR"), 
	Yaw(0), Target(0)
{
	// bṼ[h
	Mesh=LoadMesh("SceneLiveMonitor_Scene.x");
	MonitorMesh=LoadMesh("SceneLiveMonitor_Monitor.x");
}

// fXgN^
CLiveMonitor::~CLiveMonitor() {
}
	
// ړ
void CLiveMonitor::Move() {
	Yaw+=0.01f;
	Target=1-Target;
}

// `
void CLiveMonitor::Draw() {

	// G[`FbN
	if (!Mesh) { Error="Mesh"; return; }
	if (!MonitorMesh) { Error="MonitorMesh"; return; }

	// [hs
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, Yaw);
	Device->SetTransform(D3DTS_WORLD, &world);

	// r[s
	D3DXMATRIX view;
	D3DXVECTOR3 from(0, 0.5f, -10);
	D3DXVECTOR3 lookat(0, 0, 0);
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&view, &from, &lookat, &up);
	Device->SetTransform(D3DTS_VIEW, &view);
	
	// ˉes
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMATRIX proj;
	D3DXMatrixPerspectiveLH(&proj, 1, h/w, 1, 1000);
	Device->SetTransform(D3DTS_PROJECTION, &proj);

	// Cg
	Graphics->SetLight(0, D3DLIGHT_DIRECTIONAL, 1, -1, 1, 1000);

	// 
	D3DXCOLOR ambient(0.2f, 0.2f, 0.2f, 1);
	Device->SetRenderState(D3DRS_AMBIENT, ambient);

	// eNX`0ɃV[`
	SetRenderTarget(WorkTexture[Target], WorkDepthStencil[Target]);
	Graphics->Clear(BGColor);
	Mesh->Draw();

	// Cuj^̕`
	for (DWORD i=0, n=MonitorMesh->GetNumMaterials(); i<n; i++) {
		D3DMATERIAL9* mat=MonitorMesh->GetMaterial(i);
		Device->SetMaterial(mat);
		
		// Emissive0ȊO̕ɂ̓eNX`1Kp
		if (mat->Emissive.r+mat->Emissive.g+mat->Emissive.b!=0) {
			Device->SetTexture(0, WorkTexture[1-Target]);
		} else {
			Device->SetTexture(0, MonitorMesh->GetTexture(i));
		}
		MonitorMesh->DrawSubset(i);
	}

	// eNX`0ʂɕ`
	ResetRenderTarget();
	SetSamplerState(0, D3DTEXF_POINT);
	DrawTexture(WorkTexture[0], 0, 0, w, h, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));
	SetSamplerState(0, D3DTEXF_LINEAR);
}
