#include "Main.h"
#include "MagicCircle.h"


// 
static CRand Rand;
static float Rand1() { return Rand.Real1(); }
static float Rand05() { return Rand.Real1()-0.5f; }

// 萔
static const float
	InitY=1.0f, MaxXZ=2.0f;
static const int
	MinTime=30, MaxTime=200;
static const D3DXVECTOR3
	MinV(-0.01f, 0.01f, -0.01f),
	MaxV(0.01f, 0.02f, 0.01f);

//==============================================================
// q

// RXgN^
CMagicParticle::CMagicParticle(
	D3DXVECTOR3 min_color, D3DXVECTOR3 max_color
) : MinColor(min_color), MaxColor(max_color)
{
	// WȂǂ̏
	Init();
	
	// ŏɗq܂Ƃ܂ďoȂ߂̏
	for (int i=0, n=Rand1()*MaxTime; i<n; i++) Move();
}

// 
void CMagicParticle::Init() {

	// WAx
	float rad=Rand1()*D3DX_PI*2;
	Vertex.Pos=D3DXVECTOR3(
		MaxXZ*cos(rad), InitY, MaxXZ*sin(rad));
	VPos=D3DXVECTOR3(
		MinV.x+(MaxV.x-MinV.x)*Rand1(), 
		MinV.y+(MaxV.y-MinV.y)*Rand1(), 
		MinV.z+(MaxV.z-MinV.z)*Rand1());

	// F
	Vertex.Color=D3DXCOLOR(
		MinColor.x+(MaxColor.x-MinColor.x)*Rand1(),
		MinColor.y+(MaxColor.y-MinColor.y)*Rand1(),
		MinColor.z+(MaxColor.z-MinColor.z)*Rand1(), 1);

	// 
	Time=0;
	EndTime=MinTime+(MaxTime-MinTime)*Rand1();
}

// ړ
void CMagicParticle::Move() {

	// WƎԂ̍XV
	Vertex.Pos+=VPos;
	Time++;

	// IԂɂȂĂя
	if (Time>=EndTime) Init();
}

// `
void CMagicParticle::Draw(LPDIRECT3DDEVICE9 device) {
	device->DrawPrimitiveUP(D3DPT_POINTLIST, 1, &Vertex, sizeof(MAGIC_VERTEX));
}

//==============================================================
// @w̃f

// RXgN^
CMagicCircle::CMagicCircle(
	CMain* main, string title, int mode, 
	int particle_count, 
	float vyaw, D3DXVECTOR3 from, D3DXVECTOR3 lookat
)
:	CDemo(main, title), Mode(mode), 
	ParticleCount(particle_count), CircleYaw(0),
	Yaw(0), VYaw(vyaw), 
	From(from), Lookat(lookat)
{
	// bṼ[h
	MeshScene=LoadMesh("SceneMagicCircle.x");
	MeshCircle=LoadMesh("SceneMagicCircle_Circle.x");

	// q̍쐬
	Particle=new CMagicParticle*[ParticleCount];
	for (int i=0; i<ParticleCount; i++) {
		Particle[i]=new CMagicParticle(
			D3DXVECTOR3(0.5f, 0.7f, 0.9f), 
			D3DXVECTOR3(0.6f, 0.8f, 1.0f));
	}
}

// fXgN^
CMagicCircle::~CMagicCircle() {
	delete[] Particle;
}
	
// ړ
void CMagicCircle::Move() {

	// V[Ɩ@w̉]
	Yaw+=VYaw;
	CircleYaw-=0.01f;

	// q𓮂
	for (int i=0; i<ParticleCount; i++) Particle[i]->Move();
}

// `
void CMagicCircle::Draw() {

	// G[`FbN
	if (!MeshScene) { Error="MeshScene"; return; }
	if (!MeshCircle) { Error="MeshCircle"; return; }

	// [hs
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, Yaw);
	Device->SetTransform(D3DTS_WORLD, &world);

	// r[s
	D3DXMATRIX view;
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&view, &From, &Lookat, &up);
	Device->SetTransform(D3DTS_VIEW, &view);
	
	// ˉes
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMATRIX proj;
	D3DXMatrixPerspectiveLH(&proj, 1, h/w, 1, 1000);
	Device->SetTransform(D3DTS_PROJECTION, &proj);

	// Cg
	Graphics->SetLight(
		0, D3DLIGHT_POINT, 
		D3DXVECTOR3(0, 2.5f, 0), D3DXVECTOR3(0, 0, 0), 
		D3DXCOLOR(0.3f, 0.3f, 0.8f, 0), 1000);

	// 
	D3DXCOLOR ambient(0.1f, 0.1f, 0.1f, 1);
	Device->SetRenderState(D3DRS_AMBIENT, ambient);

	// V[̕`
	Graphics->Clear(BGColor);
	MeshScene->Draw();

	// At@ufBO̐ݒiZj
	if (Mode!=MAGICCIRCLE_NOADDBLEND) {
		Device->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
		Device->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_ONE);
		Device->SetRenderState(D3DRS_ZWRITEENABLE, FALSE);
	}

	// @w̕`
	for (int i=0; i<3; i++) {

		// ړAgA]̍s
		D3DXMATRIX m0, m1, m2;
		D3DXMatrixTranslation(&m0, 0, 1.0f+i*0.3f, 0);
		float s=i*0.1f+1;
		D3DXMatrixScaling(&m1, s, s, s);
		D3DXMatrixRotationY(&m2, CircleYaw*(i*0.5f+1));

		// [hs
		D3DXMatrixMultiply(&m0, &m0, &world);
		D3DXMatrixMultiply(&m0, &m0, &m1);
		D3DXMatrixMultiply(&m0, &m0, &m2);
		Device->SetTransform(D3DTS_WORLD, &m0);

		// bV̕`
		MeshCircle->Draw();
	}

	// q̕`
	if (Mode!=MAGICCIRCLE_NOPARTICLE) {

		// _`A_OAsȂǂ̐ݒ
		Device->SetFVF(D3DFVF_MAGIC_VERTEX);
		Device->SetRenderState(D3DRS_LIGHTING, FALSE);
		Device->SetRenderState(D3DRS_DIFFUSEMATERIALSOURCE, D3DMCS_COLOR1);
		Device->SetTexture(0, Main->GetDummyTexture());
		Device->SetTransform(D3DTS_WORLD, &world);

		// q̕`
		for (int i=0; i<ParticleCount; i++) {
			Particle[i]->Draw(Device);
		}

		// _O̕A
		Device->SetRenderState(D3DRS_LIGHTING, TRUE);	
	}

	// At@ufBO̐ݒiʏ퍇j
	Device->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
	Device->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);
	Device->SetRenderState(D3DRS_ZWRITEENABLE, TRUE);
}

