#ifndef MAGICCIRCLEH
#define MAGICCIRCLEH

#include "..\LibGame\Mesh.h"
#include "Demo.h"


//==============================================================
// _`

// \
struct MAGIC_VERTEX
{
	// _W
	D3DXVECTOR3 Pos;

	// F
	D3DCOLOR Color;
};

// FVF
#define D3DFVF_MAGIC_VERTEX (D3DFVF_XYZ|D3DFVF_DIFFUSE)


//==============================================================
// q

// NX
class CMagicParticle {
protected:

	// _f[^
	MAGIC_VERTEX Vertex;
	
	// x
	D3DXVECTOR3 VPos;
	
	// 
	int Time, EndTime;
	
	// F
	D3DXVECTOR3 MinColor, MaxColor;

public:

	// RXgN^
	CMagicParticle(D3DXVECTOR3 min_color, D3DXVECTOR3 max_color);

	// AړA`
	void Init();
	void Move();
	void Draw(LPDIRECT3DDEVICE9 device);
};


//==============================================================
// @w̃f

enum {
	MAGICCIRCLE_STANDARD, MAGICCIRCLE_NOPARTICLE, MAGICCIRCLE_NOADDBLEND
};

class CMagicCircle : public CDemo {
protected:

	CMesh *MeshScene, *MeshCircle;
	int Mode;
	float Yaw, VYaw, CircleYaw;
	D3DXVECTOR3 From, Lookat;

	CMagicParticle** Particle;
	int ParticleCount;

public:

	// RXgN^AfXgN^
	CMagicCircle(
		CMain* main, string title, int mode, 
		int particle_count, 
		float vyaw, D3DXVECTOR3 from, D3DXVECTOR3 lookat
	);
	virtual ~CMagicCircle();
	
	// ړA`
	virtual void Move();
	virtual void Draw();
};


#endif

