#include "Main.h"
#include "Noise.h"


//==============================================================
// mCY

// RXgN^
CNoise::CNoise(CMain* main, string title, int mode, float granularity, float min_value, float max_value)
:	CDemo(main, title), Yaw(0), NoiseShader(NULL), Mode(mode), 
	Granularity(granularity), MinValue(min_value), MaxValue(max_value)
{
	// bṼ[h
	Mesh=LoadMesh("SceneDiningA.x");

	// GtFNg̃[h
	Effect=LoadEffect("Noise.fx");
	
	// eNX`VF[_̃RpC
	LPD3DXBUFFER error;
	if (FAILED(D3DXCompileShaderFromFile(
		(ExePath+"..\\Effect\\Noise.hlsl").c_str(), NULL, NULL, 
		"NoiseTX", "tx_1_0", D3DXSHADER_DEBUG,  
		&NoiseShaderBuffer, &error, NULL)) ||
		FAILED(D3DXCreateTextureShader(
			(const DWORD*)NoiseShaderBuffer->GetBufferPointer(), 
			&NoiseShader))
	) {
		// RpCG[̏ꍇ̓G[\ďI
		MessageBox(
			NULL, (LPCTSTR)error->GetBufferPointer(), 
			"Shader Compile Error", MB_OK);
		PostQuitMessage(1);
	}
}

// fXgN^
CNoise::~CNoise() {

	// eNX`VF[_̔j
	SAFE_RELEASE(NoiseShaderBuffer);
	SAFE_RELEASE(NoiseShader);
	
	// eNX`̔j
	SAFE_RELEASE(NoiseTexture);
}
	
// foCXXg̏
void CNoise::OnLostDevice() {

	// mCYeNX`̔j
	SAFE_RELEASE(NoiseTexture);
}

// foCXZbg̏
void CNoise::OnResetDevice() {
	CDemo::OnResetDevice();

	// mCYeNX`̍쐬
	LPDIRECT3DDEVICE9 device=Graphics->GetDevice();
	device->CreateTexture(
		Graphics->GetWidth(), Graphics->GetHeight(), 1, 
		D3DUSAGE_RENDERTARGET, D3DFMT_A8R8G8B8, D3DPOOL_DEFAULT, 
		&NoiseTexture, NULL);
	if (NoiseTexture) {
		LPD3DXTEXTURESHADER ns=NoiseShader;
		if (ns) {
			ns->SetFloat(ns->GetConstantByName(NULL, "Granularity"), Granularity);
			ns->SetFloat(ns->GetConstantByName(NULL, "MinValue"), MinValue);
			ns->SetFloat(ns->GetConstantByName(NULL, "MaxValue"), MaxValue);
			D3DXFillTextureTX(NoiseTexture, NoiseShader);
		}
	}
}

// ړ
void CNoise::Move() {
	Yaw+=0.01f;
	NoiseU=Main->Rand1();
	NoiseV=Main->Rand1();
}

// `
void CNoise::Draw() {

	// G[`FbN
	if (!Mesh) { Error="Mesh"; return; }
	if (!Effect) { Error="Effect"; return; }
	if (!NoiseShader) { Error="NoiseShader"; return; }
	if (!NoiseTexture) { Error="NoiseTexture"; return; }
	if (!PS20()) { Error="PS2.0"; return; }

	// [hs
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, Yaw);
	Device->SetTransform(D3DTS_WORLD, &world);

	// r[s
	D3DXMATRIX view;
	D3DXVECTOR3 from(0, 4, 8);
	D3DXVECTOR3 lookat(0, 1, 0);
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&view, &from, &lookat, &up);
	Device->SetTransform(D3DTS_VIEW, &view);
	
	// ˉes
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMATRIX proj;
	D3DXMatrixPerspectiveLH(&proj, 1, h/w, 1, 1000);
	Device->SetTransform(D3DTS_PROJECTION, &proj);

	// Cg
	Graphics->SetLight(0, D3DLIGHT_DIRECTIONAL, 1, -1, 1, 1000);

	// 
	D3DXCOLOR ambient(0.4f, 0.4f, 0.4f, 1);
	Device->SetRenderState(D3DRS_AMBIENT, ambient);

	// eNX`0_O^[Qbgɂ
	SetRenderTarget(WorkTexture[0], WorkDepthStencil[0]);

	// eNX`̏
	Graphics->Clear(BGColor);
	
	// bV̕`
	Mesh->Draw();

	// VF[_̃p[^ݒƃeNjbN̑I
	Effect->SetFloat("NoiseU", NoiseU);
	Effect->SetFloat("NoiseV", NoiseV);
	Effect->SetTechnique("Noise");

	// eNX`ʂɕ`
	ResetRenderTarget();
	Effect->SetTexture("MeshTex", WorkTexture[0]);
	Effect->SetTexture("NoiseTex", NoiseTexture);
	if (Mode==0) {
		DrawRect(Effect, 0, 0, w, h, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));
	} else
	if (Mode==1) {
		DrawTexture(NoiseTexture, 0, 0, w, h, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));
	}
}

