#include "Main.h"
#include "Peephole.h"


//==============================================================
// ̂

// RXgN^
CPeephole::CPeephole(CMain* main, string title, string texture, int mode)
:	CDemo(main, title), 
	UV(-1.50), Time(0), Index(0), Mode(mode)
{
	// bṼ[h
	Mesh=LoadMesh("SceneBarbar.x");

	// eNX`̃[h
	Texture=LoadTexture(texture);
}

// fXgN^
CPeephole::~CPeephole() {
}
	
// ړ
void CPeephole::Move() {

	// ̂̈ړ
	float c=-cos(D3DX_PI*2*Time*0.005f)-0.5f;
	UV=(1-0.5f/(0.5f-c))*0.5f;

	// V[̐؂ւ
	Index=(Time+100)/200%4;

	// Ԃ̍XV
	Time++;
}

// `
void CPeephole::Draw() {

	// G[`FbN
	if (!Mesh) { Error="Mesh"; return; }
	if (!Texture) { Error="Texture"; return; }

	// [hs
	D3DXMATRIX world;
	D3DXMatrixIdentity(&world);
	Device->SetTransform(D3DTS_WORLD, &world);

	// r[s
	D3DXMATRIX view;
	D3DXVECTOR3 from[]={
		D3DXVECTOR3(5, 3, -5),
		D3DXVECTOR3(-5, 3, -5),
		D3DXVECTOR3(-5, 3, 5),
		D3DXVECTOR3(5, 3, 5)
	};
	D3DXVECTOR3 lookat(0, 1, 0);
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&view, &from[(Index+3)%4], &lookat, &up);
	Device->SetTransform(D3DTS_VIEW, &view);
	
	// ˉes
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMATRIX proj;
	D3DXMatrixPerspectiveLH(&proj, 1, h/w, 1, 1000);
	Device->SetTransform(D3DTS_PROJECTION, &proj);

	// Cg
	Graphics->SetLight(0, D3DLIGHT_DIRECTIONAL, 1, -1, 1, 1000);

	// 
	D3DXCOLOR ambient(0.2f, 0.2f, 0.2f, 1);
	Device->SetRenderState(D3DRS_AMBIENT, ambient);

	// ʂɃV[`
	Graphics->Clear(BGColor);
	Mesh->Draw();
	
	// ̂̃eNX``
	if (Mode==0) {
		Device->SetSamplerState(0, D3DSAMP_BORDERCOLOR, D3DXCOLOR(0, 0, 0, 1));
		Device->SetSamplerState(0, D3DSAMP_ADDRESSU, D3DTADDRESS_BORDER);
		Device->SetSamplerState(0, D3DSAMP_ADDRESSV, D3DTADDRESS_BORDER);
	}
	DrawTexture(Texture, 0, 0, w, h, UV, UV, 1-UV, 1-UV, D3DXCOLOR(1, 1, 1, 1));
	Device->SetSamplerState(0, D3DSAMP_BORDERCOLOR, D3DXCOLOR(0, 0, 0, 0));
	Device->SetSamplerState(0, D3DSAMP_ADDRESSU, D3DTADDRESS_WRAP);
	Device->SetSamplerState(0, D3DSAMP_ADDRESSV, D3DTADDRESS_WRAP);
}

