#include "Main.h"
#include "Scanline.h"


//==============================================================
// 

// RXgN^
CScanline::CScanline(CMain* main, string title, float Brightness)
:	CDemo(main, title), 
	Brightness(Brightness), Yaw(0)
{
	// bṼ[h
	Mesh=LoadMesh("SceneCactus.x");

	// GtFNg̃[h
	Effect=LoadEffect("Scanline.fx");
}

// fXgN^
CScanline::~CScanline() {
}
	
// ړ
void CScanline::Move() {
	Yaw+=0.01f;
}

// `
void CScanline::Draw() {

	// G[`FbN
	if (!Mesh) { Error="Mesh"; return; }
	if (!Effect) { Error="Effect"; return; }
	if (!PS20()) { Error="PS2.0"; return; }

	// [hs
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, Yaw);
	Device->SetTransform(D3DTS_WORLD, &world);

	// r[s
	D3DXMATRIX view;
	D3DXVECTOR3 from(0, 4, -10);
	D3DXVECTOR3 lookat(0, 1, 0);
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&view, &from, &lookat, &up);
	Device->SetTransform(D3DTS_VIEW, &view);
	
	// ˉes
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMATRIX proj;
	D3DXMatrixPerspectiveLH(&proj, 1, h/w, 1, 1000);
	Device->SetTransform(D3DTS_PROJECTION, &proj);

	// Cg
	Graphics->SetLight(0, D3DLIGHT_DIRECTIONAL, 1, -1, 1, 1000);

	// 
	D3DXCOLOR ambient(0.2f, 0.2f, 0.2f, 1);
	Device->SetRenderState(D3DRS_AMBIENT, ambient);

	// _O^[QbgieNX`j
	SetRenderTarget(WorkTexture[0], WorkDepthStencil[0]);

	// eNX`̏
	Graphics->Clear(D3DCOLOR_XRGB(128, 128, 128));
	
	// bV̕`
	Mesh->Draw();

	// VF[_̃p[^
	Effect->SetFloat("Density", h*D3DX_PI/2);
	Effect->SetFloat("Brightness", Brightness);

	// eNjbN
	Effect->SetTechnique("Scanline");

	// eNX`ʂɕ`
	ResetRenderTarget();
	Effect->SetTexture("MeshTex", WorkTexture[0]);
	DrawRect(Effect, 0, 0, w, h, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));
}

