#include "Main.h"
#include "ShadowMap.h"

#define TEX_SIZE 2048

LPDIRECT3DTEXTURE9 CShadowMap::ShadowTexture=NULL;
LPDIRECT3DSURFACE9 CShadowMap::ShadowDepthStencil=NULL;
bool CShadowMap::UseIntTexture=false;


//==============================================================
// VhE}bvɂe

// RXgN^
CShadowMap::CShadowMap(CMain* main, string title, int mode, D3DXVECTOR4 light_color)
:	CDemo(main, title), Mode(mode), Yaw(0), LightColor(light_color)
{
	// bṼ[h
	Mesh=LoadMesh("ScenePool.x");

	// GtFNg̃[h
	Effect=LoadEffect("ShadowMap.fx");
}

void CShadowMap::OnResetDevice() {
	CDemo::OnResetDevice();

	// VhE}bv̍쐬
	if (!ShadowTexture) {

		// eNX`
		UseIntTexture=false;
		Device->CreateTexture(
			TEX_SIZE, TEX_SIZE, 1, 
			D3DUSAGE_RENDERTARGET, D3DFMT_R32F, 
			D3DPOOL_DEFAULT, &ShadowTexture, NULL);
		if (!ShadowTexture) {
			Device->CreateTexture(
				TEX_SIZE, TEX_SIZE, 1, 
				D3DUSAGE_RENDERTARGET, D3DFMT_R16F, 
				D3DPOOL_DEFAULT, &ShadowTexture, NULL);
			if (!ShadowTexture) {
				Device->CreateTexture(
					TEX_SIZE, TEX_SIZE, 1, 
					D3DUSAGE_RENDERTARGET, D3DFMT_G16R16F, 
					D3DPOOL_DEFAULT, &ShadowTexture, NULL);
		
				// eNX`
				if (!ShadowTexture) {
					UseIntTexture=true;
					Device->CreateTexture(
						TEX_SIZE, TEX_SIZE, 1, 
						D3DUSAGE_RENDERTARGET, D3DFMT_G16R16, 
						D3DPOOL_DEFAULT, &ShadowTexture, NULL);
					if (!ShadowTexture) {
						Device->CreateTexture(
							TEX_SIZE, TEX_SIZE, 1, 
							D3DUSAGE_RENDERTARGET, D3DFMT_A16B16G16R16, 
							D3DPOOL_DEFAULT, &ShadowTexture, NULL);
					}
				}
			}
		}
	}

	// [xobt@̍쐬
	if (!ShadowDepthStencil) {
		Device->CreateDepthStencilSurface(
			TEX_SIZE, TEX_SIZE, D3DFMT_D16, 
			D3DMULTISAMPLE_NONE, 0, TRUE, 
			&ShadowDepthStencil, NULL);
	}
}
	
void CShadowMap::OnLostDevice() {
	CDemo::OnLostDevice();
	SAFE_RELEASE(ShadowTexture);
	SAFE_RELEASE(ShadowDepthStencil);
}

// fXgN^
CShadowMap::~CShadowMap() {
	OnLostDevice();
}
	
// ړ
void CShadowMap::Move() {
	Yaw+=0.01f;
}

// `
void CShadowMap::Draw() {

	// G[`FbN
	if (!PS20()) { Error="PS2.0"; return; }
	if (!Mesh) { Error="Mesh"; return; }
	if (!Effect) { Error="Effect"; return; }
	if (!ShadowTexture) { Error="ShadowTexture"; return; }
	if (!ShadowDepthStencil) { Error="ShadowDepthStencil"; return; }

	// [hs
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, Yaw);
	Effect->SetMatrix("World", &world);

	// [hr[s
	D3DXMATRIX wview;
	D3DXVECTOR3 from(0, 4, -6);
	D3DXVECTOR3 lookat(0, 1, 0);
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&wview, &from, &lookat, &up);
	D3DXMatrixMultiply(&wview, &world, &wview);
	Effect->SetMatrix("WView", &wview);
	
	// [hr[ˉes
	D3DXMATRIX wvproj;
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMatrixPerspectiveLH(&wvproj, 1, h/w, 1, 1000);
	D3DXMatrixMultiply(&wvproj, &wview, &wvproj);
	Effect->SetMatrix("WVProj", &wvproj);

	// 
	D3DXVECTOR4 ambient(0.2f, 0.2f, 0.2f, 1);
	Effect->SetVector("Ambient", &ambient);

	// Cg̈ʒu
	D3DXVECTOR3 light_pos(-12, 4, -12);
	Effect->SetValue("LightWPos", &light_pos, sizeof(D3DXVECTOR3));

	// Cg猩Ƃ̃r[s
	D3DXMATRIX light_view;
	D3DXVECTOR3 light_lookat(0, 0, 0);
	D3DXVECTOR3 light_up(0, 1, 0);
	D3DXMatrixLookAtLH(&light_view, &light_pos, &light_lookat, &light_up);

	// Cg猩Ƃ̃r[ˉes
	D3DXMATRIX light_vproj;
	D3DXMatrixPerspectiveLH(&light_vproj, 1, 1, 1, 1000);
	D3DXMatrixMultiply(&light_vproj, &light_view, &light_vproj);
	Effect->SetMatrix("LightVProj", &light_vproj);

	// VhE}bv̍쐬
	SetRenderTarget(ShadowTexture, ShadowDepthStencil);
	Graphics->Clear();
	Effect->SetVector("LightColor", &LightColor);
	Effect->SetTexture("ShadowTex", ShadowTexture);
	Effect->SetTechnique("Shadow");
	Effect->SetFloat("Margin", 0.001f);
	if (UseIntTexture) Effect->SetFloat("Margin", 0.002f);
	DrawMesh(Mesh, Effect);

	// V[̕`
	ResetRenderTarget();
	Graphics->Clear();
	if (Mode==0) {
		Effect->SetTechnique("Scene");
		DrawMesh(Mesh, Effect);
	}
	if (Mode==1) {
		Effect->SetTechnique("SceneNoShadow");
		DrawMesh(Mesh, Effect);
	}
	if (Mode==2) {
		Effect->SetTechnique("ShowShadow");
		DrawRect(Effect, 0, 0, w, h, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));
	}
}

