#include "Main.h"
#include "ShadowVolume.h"


//==============================================================
// VhE{[

// RXgN^
CShadowVolume::CShadowVolume(
	CMain* main, string title, int mode,
	D3DXCOLOR shadow_color, D3DXCOLOR volume_color
)
:	CDemo(main, title), Mode(mode), Yaw(0),
	ShadowColor(shadow_color), VolumeColor(volume_color)
{
	// bṼ[h
	Mesh=LoadMesh("ScenePool.x");
	MeshShadowed=LoadMesh("ScenePool_Shadow.x");

	// GtFNg̃[h
	Effect=LoadEffect("ShadowVolume.fx");
}

// fXgN^
CShadowVolume::~CShadowVolume() {
}
	
// ړ
void CShadowVolume::Move() {
	Yaw+=0.01f;
}

// `
void CShadowVolume::Draw() {

	// G[`FbN
	if (!Mesh) { Error="Mesh"; return; }
	if (!MeshShadowed) { Error="MeshShadowed"; return; }
	if (!Effect) { Error="Effect"; return; }

	// [hs
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, Yaw);
	Effect->SetMatrix("World", &world);

	// [hr[s
	D3DXMATRIX w_view;
	D3DXVECTOR3 from(0, 4, -6);
	D3DXVECTOR3 lookat(0, 1, 0);
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&w_view, &from, &lookat, &up);
	D3DXMatrixMultiply(&w_view, &world, &w_view);
	Effect->SetMatrix("WView", &w_view);
	
	// [hr[ˉes
	D3DXMATRIX wv_proj;
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMatrixPerspectiveLH(&wv_proj, 1, h/w, 1, 1000);
	Effect->SetMatrix("Proj", &wv_proj);
	D3DXMatrixMultiply(&wv_proj, &w_view, &wv_proj);
	Effect->SetMatrix("WVProj", &wv_proj);

	// Cg
	D3DXVECTOR4 light(3, -1, 3, 0);
	D3DXVec4Normalize(&light, &light);
	Effect->SetVector("Light", &light);

	// 
	D3DXVECTOR4 ambient(0.2f, 0.2f, 0.2f, 1);
	Effect->SetVector("Ambient", &ambient);

	//==========================================================
	// V[̕`
	Effect->SetTechnique("Basic");
	Device->Clear(0, NULL, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER, BGColor, 1, 0);
	DrawMesh(Mesh, Effect);

	//==========================================================
	// VhEpV[̕`
	Effect->SetTechnique("ZOnly");
	Device->Clear(0, NULL, D3DCLEAR_ZBUFFER, BGColor, 1, 0);
	DrawMesh(MeshShadowed, Effect);	

	//==========================================================
	// VhE{[̕`

	// p[^ƃeNjbN
	Effect->SetVector("VolumeColor", (D3DXVECTOR4*)&VolumeColor);
	Effect->SetFloat("NearZ", 1);
	Effect->SetFloat("FarZ", 1000);
	Effect->SetTechnique("Volume");

	if (Mode&1) Effect->SetTechnique("ShowVolume");

	// XeVobt@̃NA
	Device->Clear(0, NULL, D3DCLEAR_STENCIL, BGColor, 1, 0);

	// bV̕`
	DrawMesh(MeshShadowed, Effect);

	//==========================================================
	// VhE̕`
	if (Mode&2) Device->Clear(0, NULL, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER, D3DXCOLOR(0, 0, 0, 1), 1, 0);
	Effect->SetTechnique("Shadow");
	DrawRect(Effect, 0, 0, w, h, 0, 0, 1, 1, ShadowColor);
}


