#include "Main.h"
#include "Spiral.h"


//==============================================================
// Q

// RXgN^
CSpiral::CSpiral(CMain* main, string title)
:	CDemo(main, title), 
	RadScale(1), RadOffset(0), 
	Time(0), Index(0)
{
	// bṼ[h
	Mesh=LoadMesh("SceneCactus.x");

	// GtFNg̃[h
	Effect=LoadEffect("Spiral.fx");
}

// fXgN^
CSpiral::~CSpiral() {
}
	
// ړ
void CSpiral::Move() {

	// Q̊ω
	RadScale=(0.5f-cos(D3DX_PI*2*Time*0.002f)*0.5f)*100;

	// V[̐؂ւ
	Index=(Time+250)/500%4;

	// Ԃ̍XV
	Time++;
}

// `
void CSpiral::Draw() {

	// G[`FbN
	if (!Mesh) { Error="Mesh"; return; }
	if (!Effect) { Error="Effect"; return; }
	if (!PS20()) { Error="PS2.0"; return; }

	// [hs
	D3DXMATRIX world;
	D3DXMatrixIdentity(&world);
	Device->SetTransform(D3DTS_WORLD, &world);

	// r[s
	D3DXMATRIX view;
	D3DXVECTOR3 from[]={
		D3DXVECTOR3(5, 3, -5),
		D3DXVECTOR3(-5, 3, -5),
		D3DXVECTOR3(-5, 3, 5),
		D3DXVECTOR3(5, 3, 5)
	};
	D3DXVECTOR3 lookat(0, 1, 0);
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&view, &from[Index], &lookat, &up);
	Device->SetTransform(D3DTS_VIEW, &view);
	
	// ˉes
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMATRIX proj;
	D3DXMatrixPerspectiveLH(&proj, 1, h/w, 1, 1000);
	Device->SetTransform(D3DTS_PROJECTION, &proj);

	// Cg
	Graphics->SetLight(0, D3DLIGHT_DIRECTIONAL, 1, -1, 1, 1000);

	// 
	D3DXCOLOR ambient(0.2f, 0.2f, 0.2f, 1);
	Device->SetRenderState(D3DRS_AMBIENT, ambient);

	// eNX`ɃbV`
	SetRenderTarget(WorkTexture[0], WorkDepthStencil[0]);
	Graphics->Clear(BGColor);
	Mesh->Draw();

	// GtFNgKpăeNX`ʂɕ`
	ResetRenderTarget();
	Effect->SetFloat("RadScale", RadScale);
	Effect->SetFloat("RadOffset", RadOffset);
	Effect->SetTechnique("Spiral");
	Effect->SetTexture("Tex", WorkTexture[0]);
	DrawRect(Effect, 0, 0, w, h, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));
}

