#include "Main.h"
#include "VolumeFog.h"

LPDIRECT3DTEXTURE9 CVolumeFog::DepthTexture[]={NULL, NULL, NULL};
bool CVolumeFog::UseIntTexture=false;

// RXgN^
CVolumeFog::CVolumeFog(
	CMain* main, string title, int mode, 
	float vyaw, D3DXVECTOR3 from, D3DXVECTOR3 lookat, 
	string mesh, float fog_scale, D3DXVECTOR4 fog_color
)
:	CDemo(main, title), Mode(mode), 
	Yaw(0), VYaw(vyaw), 
	From(from), Lookat(lookat),
	FogScale(fog_scale), FogColor(fog_color)
{
	// bṼ[h
	MeshScene=LoadMesh(mesh+".x");
	MeshFog=LoadMesh(mesh+"_Fog.x");

	// GtFNg̃[h
	Effect=LoadEffect("VolumeFog.fx");
}

// foCXZbg
void CVolumeFog::OnResetDevice() {
	CDemo::OnResetDevice();

	// [x}bv̍쐬
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	for (int i=0; i<sizeof(DepthTexture)/sizeof(LPDIRECT3DTEXTURE9); i++) {
		if (!DepthTexture[i]) {
			
			// eNX`
			UseIntTexture=false;
			Device->CreateTexture(
				w, h, 1, D3DUSAGE_RENDERTARGET, D3DFMT_G16R16F, 
				D3DPOOL_DEFAULT, &DepthTexture[i], NULL);

			// eNX`
			if (!DepthTexture[i]) {
				UseIntTexture=true;
				Device->CreateTexture(
					w, h, 1, D3DUSAGE_RENDERTARGET, D3DFMT_G16R16, 
					D3DPOOL_DEFAULT, &DepthTexture[i], NULL);
				if (!DepthTexture[i]) {
					UseIntTexture=true;
					Device->CreateTexture(
						w, h, 1, D3DUSAGE_RENDERTARGET, D3DFMT_A16B16G16R16, 
						D3DPOOL_DEFAULT, &DepthTexture[i], NULL);
				}
			}
		}
	}
}

// foCXXg
void CVolumeFog::OnLostDevice() {
	CDemo::OnLostDevice();
	for (int i=0; i<sizeof(DepthTexture)/sizeof(LPDIRECT3DTEXTURE9); i++) {
		SAFE_RELEASE(DepthTexture[i]);
	}
}

// fXgN^
CVolumeFog::~CVolumeFog() {
	OnLostDevice();
}
	
// ړ
void CVolumeFog::Move() {

	// V[̉]
	Yaw+=VYaw;
}

// `
void CVolumeFog::Draw() {

	// G[`FbN
	if (!PS20()) { Error="PS2.0"; return; }
	if (!MeshScene) { Error="MeshScene"; return; }
	if (!MeshFog) { Error="MeshFog"; return; }
	if (!Effect) { Error="Effect"; return; }
	for (int i=0; i<sizeof(DepthTexture)/sizeof(LPDIRECT3DTEXTURE9); i++) {
		if (!DepthTexture[i]) { Error="DepthTexture"+ToStr(i); return; }
	}

	// [hs
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, Yaw);
	Effect->SetMatrix("World", &world);

	// [hr[s
	D3DXMATRIX w_view;
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&w_view, &From, &Lookat, &up);
	D3DXMatrixMultiply(&w_view, &world, &w_view);
	Effect->SetMatrix("WView", &w_view);
	
	// [hr[ˉes
	D3DXMATRIX wv_proj;
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMatrixPerspectiveLH(&wv_proj, 1, h/w, 1, 1000);
	D3DXMatrixMultiply(&wv_proj, &w_view, &wv_proj);
	Effect->SetMatrix("WVProj", &wv_proj);

	// Cg
	Effect->SetVector("LightWVPos", &D3DXVECTOR4(0, 2.5f, 0, 1));
	Effect->SetVector("LightColor", &D3DXVECTOR4(0.3f, 0.3f, 0.8f, 0));

	// 
	Effect->SetVector("Ambient", &D3DXVECTOR4(0.2f, 0.2f, 0.2f, 1));

	// eNX`ւ̑Ή
	Effect->SetFloat("IntScale", 1.00f);
	if (UseIntTexture) Effect->SetFloat("IntScale", 0.01f);

	// V[̕`
	ResetRenderTarget();
	Effect->SetTechnique("Scene");
	Device->Clear(0, NULL, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER, BGColor, 1, 0);
	DrawMesh(MeshScene, Effect);

	// eNX`0NA
	SetRenderTarget(DepthTexture[0], OrgDepthStencil);
	Device->Clear(0, NULL, D3DCLEAR_ZBUFFER, 0, 1, 0);
	Effect->SetTechnique("Clear");
	Effect->SetVector("ClearColor", &D3DXVECTOR4(10000, 0, 0, 1));
	DrawRect(Effect, 0, 0, w, h, 0, 0, 1, 1, 0);

	// eNX`0ɃV[Zl`
	Effect->SetTechnique("DepthScene");
	DrawMesh(MeshScene, Effect);

	// eNX`1Ƀ{[tHOZl`ij
	SetRenderTarget(DepthTexture[1], OrgDepthStencil);
	Effect->SetTexture("DepthTex0", DepthTexture[0]);
	Effect->SetTechnique("DepthFogCW");
	Device->Clear(0, NULL, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER, 0, 0, 0);
	DrawMesh(MeshFog, Effect);

	// eNX`2Ƀ{[tHOZl`i\j
	SetRenderTarget(DepthTexture[2], OrgDepthStencil);
	Effect->SetTechnique("DepthFogCCW");
	Effect->SetTexture("DepthTex0", DepthTexture[0]);
	Device->Clear(0, NULL, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER, 0, 1, 0);
	DrawMesh(MeshFog, Effect);

	// {[tHO̕`
	ResetRenderTarget();
	Effect->SetTechnique("Fog");
	Effect->SetTexture("DepthTex0", DepthTexture[1]);
	Effect->SetTexture("DepthTex1", DepthTexture[2]);
	Effect->SetFloat("FogScale", FogScale);
	Effect->SetVector("FogColor", &FogColor);
	DrawRect(Effect, 0, 0, w, h, 0, 0, 1, 1, 0);

	if (Mode==VOLUMEFOG_DEPTHSCENE) {
		Effect->SetTechnique("ShowDepth");
		Effect->SetTexture("DepthTex0", DepthTexture[0]);
		Graphics->Clear();
		DrawRect(Effect, 0, 0, w, h, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));
	}
	if (Mode==VOLUMEFOG_DEPTHCW) {
		Effect->SetTechnique("ShowDepth");
		Effect->SetTexture("DepthTex0", DepthTexture[1]);
		Graphics->Clear();
		DrawRect(Effect, 0, 0, w, h, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));
	}
	if (Mode==VOLUMEFOG_DEPTHCCW) {
		Effect->SetTechnique("ShowDepth");
		Effect->SetTexture("DepthTex0", DepthTexture[2]);
		Graphics->Clear();
		DrawRect(Effect, 0, 0, w, h, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));
	}
	if (Mode==VOLUMEFOG_DEPTHDIFF) {
		Effect->SetTechnique("ShowDepthDiff");
		Effect->SetTexture("DepthTex0", DepthTexture[1]);
		Effect->SetTexture("DepthTex1", DepthTexture[2]);
		Graphics->Clear();
		DrawRect(Effect, 0, 0, w, h, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));
	}
}

