#include "Main.h"
#include "Wave.h"

#define TEX_SIZE 256
LPDIRECT3DTEXTURE9 CWave::HeightTexture[2]={NULL, NULL};
LPDIRECT3DTEXTURE9 CWave::NormalTexture=NULL;

// 
static CRand Rand;
static float Rand1() { return Rand.Real1(); }
static float Rand05() { return Rand.Real1()-0.5f; }


//==============================================================
// g

// RXgN^
CWave::CWave(
	CMain* main, string title, int mode, float vyaw, 
	D3DXVECTOR3 from, D3DXVECTOR3 lookat, 
	D3DXVECTOR3 lpos, D3DXVECTOR3 lcol
)
:	CDemo(main, title), Mode(mode), Yaw(0), VYaw(vyaw), 
	From(from), Lookat(lookat), 
	LightWVPos(D3DXVECTOR4(lpos, 1)), 
	LightColor(D3DXVECTOR4(lcol, 1)),
	Time(0), TextureTime(0)
{
	// bṼ[h
	Mesh=LoadMesh("SceneFishing.x");
	MeshWave=LoadMesh("SceneFishing_Wave.x");
	
	// GtFNg̃[h
	Effect=LoadEffect("Wave.fx");
}

// foCXZbg
void CWave::OnResetDevice() {
	CDemo::OnResetDevice();

	// x}bv̍쐬
	for (int i=0; i<2; i++) {
		if (!HeightTexture[i]) {
			Device->CreateTexture(
				TEX_SIZE, TEX_SIZE, 1, D3DUSAGE_RENDERTARGET, D3DFMT_G16R16F, 
				D3DPOOL_DEFAULT, &HeightTexture[i], NULL);
		}
	}

	// @}bv̍쐬
	if (!NormalTexture) {
		Device->CreateTexture(
			TEX_SIZE, TEX_SIZE, 1, D3DUSAGE_RENDERTARGET, D3DFMT_G16R16F, 
			D3DPOOL_DEFAULT, &NormalTexture, NULL);
	}
	
	// eNX`̃NA
	for (int i=0; i<2; i++) {
		if (HeightTexture[i]) {
			SetRenderTarget(HeightTexture[i], NULL);
			Device->Clear(0, NULL, D3DCLEAR_TARGET, 0, 1, 0);
		}
	}
	if (NormalTexture) {
		SetRenderTarget(NormalTexture, NULL);
		Device->Clear(0, NULL, D3DCLEAR_TARGET, 0, 1, 0);
	}
	ResetRenderTarget();
}

// foCXXg
void CWave::OnLostDevice() {
	CDemo::OnLostDevice();
	for (int i=0; i<2; i++) SAFE_RELEASE(HeightTexture[i]);
	SAFE_RELEASE(NormalTexture);
}

// fXgN^
CWave::~CWave() {
	OnLostDevice();
}
	
// ړ
void CWave::Move() {
	Time++;
	Yaw+=VYaw;
}

// `
void CWave::Draw() {

	// G[`FbN
	if (!PS20()) { Error="PS2.0"; return; }
	if (!Mesh) { Error="Mesh"; return; }
	if (!MeshWave) { Error="MeshWave"; return; }
	if (!Effect) { Error="Effect"; return; }
	for (int i=0; i<2; i++) {
		if (!HeightTexture[i]) { Error="HeightTexture"+ToStr(i); return; }
	}
	if (!NormalTexture) { Error="NormalTexture"; return; }

	// [hs
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, Yaw);
	Effect->SetMatrix("World", &world);

	// [hr[s
	D3DXMATRIX w_view;
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&w_view, &From, &Lookat, &up);
	D3DXMatrixMultiply(&w_view, &world, &w_view);
	Effect->SetMatrix("WView", &w_view);
	
	// [hr[ˉes
	D3DXMATRIX wv_proj;
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMatrixPerspectiveLH(&wv_proj, 1, h/w, 1, 1000);
	Effect->SetMatrix("Proj", &wv_proj);
	D3DXMatrixMultiply(&wv_proj, &w_view, &wv_proj);
	Effect->SetMatrix("WVProj", &wv_proj);

	// Cg
	Effect->SetVector("LightWVPos", &LightWVPos);
	Effect->SetVector("LightColor", &LightColor);

	// 
	Effect->SetVector("Ambient", &D3DXVECTOR4(0.2f, 0.2f, 0.2f, 1));

	// V[̕`
	ResetRenderTarget();
	Effect->SetTechnique("Scene");
	Graphics->Clear(BGColor);
	DrawMesh(Mesh, Effect);
	
	// g̓
	if (TextureTime!=Time) {
		TextureTime=Time;

		// Vg̐
		if (TextureTime%100==1) {
			Effect->SetVector("AddWavePos", &D3DXVECTOR4(0.6f, 0.3f, 0, 0));
			Effect->SetFloat("AddWaveRad", Rand1()*0.01f);
			Effect->SetFloat("AddWaveVelocity", Rand05());
		}

		// x}bv̍XV
		SetRenderTarget(HeightTexture[TextureTime%2], NULL);
		Effect->SetTexture("HeightTex", HeightTexture[1-TextureTime%2]);
		Effect->SetTechnique("Height");
		Effect->SetFloat("Spring", 0.03f);
		DrawRect(Effect, 0, 0, TEX_SIZE, TEX_SIZE, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));

		// @}bv̍XV
		SetRenderTarget(NormalTexture, NULL);
		Effect->SetTexture("HeightTex", HeightTexture[TextureTime%2]);
		Effect->SetTechnique("Normal");
		DrawRect(Effect, 0, 0, TEX_SIZE, TEX_SIZE, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));
	}

	// g̕`
	ResetRenderTarget();
	Effect->SetTechnique("Wave");
	Effect->SetVector("WaveDiffuse", &D3DXVECTOR4(0.6f, 0.8f, 1.0f, 0.7f));
	Effect->SetVector("WaveSpecular", &D3DXVECTOR4(1.6f, 1.8f, 2.0f, 0));
	Effect->SetFloat("WavePower", 4);
	Effect->SetTexture("NormalTex", NormalTexture);
	if (Mode==WAVE_NOSPECULAR) Effect->SetVector("WaveSpecular", &D3DXVECTOR4(0, 0, 0, 0));
	DrawMesh(MeshWave, Effect);

	if (Mode==WAVE_HEIGHT) {
		Graphics->Clear();
		Effect->SetTexture("HeightTex", HeightTexture[TextureTime%2]);
		Effect->SetTechnique("ShowHeight");
		DrawRect(Effect, 0, 0, w, h, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));
	}
	if (Mode==WAVE_VELOCITY) {
		Graphics->Clear();
		Effect->SetTexture("HeightTex", HeightTexture[TextureTime%2]);
		Effect->SetTechnique("ShowVelocity");
		DrawRect(Effect, 0, 0, w, h, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));
	}
	if (Mode==WAVE_NORMAL) {
		Graphics->Clear();
		Effect->SetTexture("NormalTex", NormalTexture);
		DrawTexture(NormalTexture, 0, 0, w, h, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));
	}
}

