#ifndef ANIMMESHH
#define ANIMMESHH

#include "Mesh.h"
#include <d3dx9.h>
#include <string>
using namespace std;


class CMeshContainer;


//==============================================================
// t[ƃbVReiǂݍނ߂Ɏgp
// ID3DXAllocateHierarchy̔hNX
class CAllocateHierarchy: public ID3DXAllocateHierarchy {
public:
	STDMETHOD(CreateFrame)(
		THIS_ LPCTSTR name, LPD3DXFRAME *new_frame);
	STDMETHOD(CreateMeshContainer)(
		THIS_ LPCSTR name, 
		CONST D3DXMESHDATA *mesh_data,
		CONST D3DXMATERIAL *materials, 
		CONST D3DXEFFECTINSTANCE *effect_instances,
		DWORD num_materials, 
		CONST DWORD *adjacency, 
		LPD3DXSKININFO skin_info, 
		LPD3DXMESHCONTAINER *new_mesh_container);
	STDMETHOD(DestroyFrame)(
		THIS_ LPD3DXFRAME frame_to_tree);
	STDMETHOD(DestroyMeshContainer)(
		THIS_ LPD3DXMESHCONTAINER mesh_container_base);
};


//==============================================================
// t[
class CFrame : public D3DXFRAME {
private:

	// bVReiAZt[Aqt[
	CMeshContainer* MeshContainer;
	CFrame* Sibling;
	CFrame* Child;

	// ςݕό`s
	D3DXMATRIXA16 CombinedTransMatrix;

public:

	// RXgN^AfXgN^
	CFrame(LPCTSTR name);
	~CFrame();

	// s̎擾
	LPD3DXMATRIXA16 GetCombinedTransMatrix() {
		return &CombinedTransMatrix;
	}
	
	// t[̌
	CFrame* Find(LPCTSTR name);

	// {[ό`s̏
	void InitBoneTransMatrices(CFrame* root);

	// ό`s̍XV
	void UpdateMatrices(LPD3DXMATRIX parent_mat);

	// `
	void Draw();
};


//==============================================================
// _̃[h
typedef enum {
	VP_HLSL, VP_INDEXED, VP_SOFTWARE
} VPMODE;


//==============================================================
// bVRei
class CMeshContainer : public D3DXMESHCONTAINER {
private:

	// bV
	ID3DXMesh* Mesh;

	// }eA̐A}eAAeNX`
	DWORD NumMaterials;
	D3DMATERIAL9* Materials;
	LPDIRECT3DTEXTURE9* Textures;

	// XL
	LPD3DXSKININFO SkinInfo;

	// {[̐AItZbgsAgXtH[s
	DWORD NumBones;
	D3DXMATRIX* BoneOffsetMatrices;
	D3DXMATRIX** BoneTransMatrices;

	// {[spbg̐Aɉe{[̍ő吔
    DWORD NumPaletteEntries;
	DWORD NumMaxInfls;

	// {[̑gݍ킹̐A{[̑gݍ킹
	DWORD NumBoneCombinations;
	LPD3DXBUFFER BoneCombinations;

	// _̃[h
	VPMODE VPMode;

public:

	// RXgN^
	CMeshContainer(
		THIS_ LPCTSTR name,
		CONST D3DXMESHDATA *mesh_data,
		CONST D3DXMATERIAL *materials,
		DWORD num_materials,
		LPD3DXSKININFO skin_info,
		CONST DWORD *adjacency
	);

	// fXgN^
	~CMeshContainer();

	// ̃bVRei擾
	CMeshContainer* Next() {
		return (CMeshContainer*)pNextMeshContainer;
	}

	// {[ό`s̏
	void InitBoneTransMatrices(CFrame* root);

	// `
	void Draw(CFrame* frame);
};


//==============================================================
// Aj[VΉbV
class CAnimMesh {
private:

	// foCX
	LPDIRECT3DDEVICE9 Device;

	// [g̃t[
	CFrame* FrameRoot;

	// Aj[VRg[
	LPD3DXANIMATIONCONTROLLER AnimController;

public:

	// RXgN^CfXgN^
	CAnimMesh(LPDIRECT3DDEVICE9 device);
	~CAnimMesh();

	// t@C̓ǂݍ
	void LoadFromFile(string file);

	// Aj[V
	double GetAnimTime();
	void AdvanceAnimTime(double time);
	void SetAnimSet(DWORD track, DWORD set);
	void SetAnimEnabled(DWORD track, bool enabled);
	void SetAnimWeight(DWORD track, float weight);
	void SetAnimSpeed(DWORD track, float speed);
	DWORD GetAnimNumTracks();

	// t[̎擾
	CFrame* GetFrameRoot() { return FrameRoot; }

	// `
	void Draw(LPD3DXMATRIX mat);
	void Draw();
	void Draw(
		float x, float y, float z, 
		float sx, float sy, float sz, 
		float tx, float ty, float tz, TURN_ORDER order);
};


#endif
