#ifndef GAMEH
#define GAMEH

#include "Graphics.h"
#include "Image.h"
#include "Input.h"
#include <vector>
#include <string>
using namespace std;


#define IDC_EXIT 0
#define IDC_TOGGLEFULLSCREEN 1
#define IDC_HELPURL 2
#define IDC_VERSION 3


// Q[{̂̃NX
class CGame {
protected:

	// ANZ[^L[
	HACCEL HAccel;

	// EBhEnh
	HWND HWnd;

	// OtBbNX
	CGraphics* Graphics;

	// 
	CInput* Input;
	MOUSE_STATE Mouse;

	// st@C̃pXAAvP[VAwvURL
	string ExePath, AppName, HelpURL;

	// x
	LARGE_INTEGER LastPerfCounter;
	DWORD LastTickCount;
	double Elapsed;
	void ResetTime();

	// ꎞ~
	bool Pause, MenuPause;

	// j[
	bool UseMenu;
	HMENU MenuBar;

	// ImF
	bool ConfirmExit;

	// ʃTCYAtbV[g
	int WindowWidth, WindowHeight, FullScreenWidth, FullScreenHeight,
		RefreshRate;
	bool FullScreen;
	
	void DrawScene();

public:

	// RXgN^CfXgN^
	CGame(const char* app_name, bool zbuffer, bool use_menu, bool fixed_size);
	~CGame();

	// bZ[Wnh
	virtual LRESULT WINAPI WndProc(UINT msg, WPARAM wparam, LPARAM lparam);

	// Q[̎s
	void Run();

	// eݒ
	double FPS;
	bool DropFrames, PauseInTheBackground;

	// ړƕ`F
	// TuNXŃI[o[Ch
	virtual void Move() {}
	virtual void Draw() {}
	
	// Direct3D\[X̊Ǘ
	virtual void OnLostDevice() {}
	virtual void OnResetDevice() {}

	// j[
	HMENU GetMenuBar() { return MenuBar; }
	HMENU AddMenu(string text);
	HMENU AddSubMenu(HMENU menu, string text);
	void AddMenuItem(HMENU menu, string text, int id);
	void AddMenuSeparator(HMENU menu);
	void CheckMenuItem(HMENU menu, int id, bool check);

	// }EX̏
	const MOUSE_STATE& GetMouseState() { return Mouse; }

	// ImF
	void SetConfirmExit(bool ce) { ConfirmExit=ce; }

	// ʃ[h̐؂ւ
	void ResetScreen();
	void ToggleFullScreen();
};


#endif
